*       *********************************************************
*       *                                                         
*       * 2012.04.25            LIQNOM2.PRG              16:25:37 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Ing Gustavo A. Pinilla C.                               
*       *                                                         
*       * Copyright (c) 2012 SIE7E Ltda.                          
*       * Cel 310.421.2741                                        
*       * Cali, Valle  76001                                         
*       * Colombia                                          
*       *                                                         
*       * Description:                                            
*       * Este programa lo ha generado automticamente GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS mtipo,wautomatic

*       *********************************************************
*       *                                                         
*       *   LIQNOM/Windows Cdigo de configuracin - SECCION 1    
*       *                                                         
*       *********************************************************
*

#REGION 1
*******************************************************
*      Programa. LIQNOM2.PRG                          *
*      Programa que liquida la Nomina. DIC.04/97      *
*      ACTUALIZADO    : GUSTAVO A. PINILLA C.  2005   *
*      MTIPO          : 'D' = DEFINITIVA              *
*                       'T' = TENTATIVA               *
*      wautomatic     : .T./.F. = Acumula inmediata/  *
*      Version 01 : Aplica Filtro por Centro de       *
*                   Costos en tabla Empleado. Sep-05  *
*              02 :                                   *
*              02B: Ajust Min Garantizado             *
*              02C: Revisamos si hay grupos negocios  *
*                   y codigos de agencias             *
*              02D: Mensajes de ayuda en Conc sin fac *
*              03 : Liq de Prestamos con Intereses    *
*              03A: Incluimos  Conc Fijos x Negocio   *
*                   LIQNOMCN.FXP                      *
*              03B: Corregimos liq de min Garantizad  *
*                C: Incluimos ind incap para pagares  *
*                D: Incluimos cuotas de pagare en Vac *
*                E: Act suma de dias para Tnt por usu *
*                F: Agregamos OPc para NO liq pagares *
*                G: Corregiimos selec x Trabaj-cnt    *
*                H: Seek empleado.nitemple+contw      *
*                I: Correccion variable men --> _men  *
*                J: Separamos anticipos por Ao/conso *
*                k: incluimos dominical prop          *
*                L: Incluimos cncs per_remun xa subtr *
*                M: Concepto Bas-Variable Unid y Vlr  *
*                N: Retroactivo de salario            *
*                O: Se ajusta fec_up2 para tipcont=D  *
*                P: Se agrega liqnomrv para buscar    *
*                   diferencias en la liq Def vs Tnt  *
*                Q: Ajuste mdias2, para proy cuando   *
*                   se paga sola la prima             *
*                R: Agregamos preg xa Borrar Tent Ant *
*                S: Correccion mdias2 ... como 03Q    *
*                   Cerramos contratos de Aprendices  *
*                   Incr Contador Para renov cnts TF  *
*                T: Excluimos de PRIMA a los apredices*
*                U: Cargamos vars de dia_31 y feb 30  *
*                V: Agregamos control informativo de  *
*                   las renovaciones de contratos     *
*               04: 2010/01/30: CREAMOS SCREEN LIQNOM *
*                B: AGREGAMOS INFORME LIQNOMRT        *
*                C: Agregamos LIQNOMLS AUTOMATICO     *
*                D: 2010/05/10 Agregamos detalles visu*
*                   2010.07/10 Condic Liq Seg Secial  *
*                   2010.08.15 close_Data al principio*
*                   2010.08.25 Recalculo para SS, y AT*
*                   2010.09.22 Recalc. CF prop ac Mes *
*                e: 2010.10.15 Se permite Nov xa Reliq*
*                E: 2010.12.15 Buscar usuarios/ncontrol
*                   para cerrar.                      *
*               05: 2010.12.28 [] PerAnteriores Sacamos ConcFijosx Neg del IF       *
*                   2011.03.06 Tomamos empleado.hrsmes*
*                   2011.03.10 Agregamos liquidacion de concep ex-nomina prov/fact  *
*                   2011.09.07 Agreagamos [x] Paramet *
*                A: 2012.01.18 Se agrega func abrir0  *
*                   2012.02.14 Se guarda el vlr de tnt y se compara vs definitiva   *
*                   2012.02.15 Correccion error de inconsis. (estado --> liqestado) *
*                   2012.02.17 Se cambia ordmto consulta nmperiod                   *
*                   2012.03.26 Agregamos inconsistencia HRA INFERIOR A SML          *
*                   2012.03.30 AGREGA VALID de liqnomau.fxp para auditoria          *
*************************************************************************************
IF PARAMETERS()=0
   mtipo = 'T'
   wautomatic = .F.
ENDIF

_nomprg = "liqnom"
_c13    = CHR(13)
SET PROC TO LOCKS
DO INICIAL

_i = 1
FOR _i =1 TO 250
   SELECT (_i)
   IF "NCONTROL.DBF" $ UPPER(DBF()) OR ;
      "USUARIOS.DBF" $ UPPER(DBF()) OR ;
      "PARA7SRH.DBF" $ UPPER(DBF()) OR ;
      "FLEX7SRH.DBF" $ UPPER(DBF()) OR ;
      "EMPLEADO.DBF" $ UPPER(DBF()) OR ;
      "EMPRESAS.DBF" $ UPPER(DBF()) OR ;
      "CENCOSTO.DBF" $ UPPER(DBF()) OR ;
      "SELPR001.DBF" $ UPPER(DBF()) OR ;
      "DATBAS01.DBF" $ UPPER(DBF()) OR ;
      "TABGEN00.DBF" $ UPPER(DBF()) OR ;
      "SUBCON.DBF" $ UPPER(DBF()) OR ;
      "CONCEPTO.DBF" $ UPPER(DBF())
      USE
   ENDIF
ENDFOR

RELEASE WINDOW w_liqnom
RELEASE WINDOW w_liqnom2

IF TYPE('mtipo')#'C'
   mtipo = 'T'
ENDIF

IF mtipo # 'D'
   wautomatic = .F.
   wc_tipo =[TENTATIVA]
ELSE
   wc_tipo =[DEFINITIVA]
ENDIF

w_audita = .F.

ON KEY LABEL ESC
ON KEY LABEL PGDN
ON KEY LABEL F6
SET FUNCTION 6 TO
SET READBORDER ON
SET DECIMAL TO 3

** aseguro el formato a ymd   &&
_century_ = set("CENTURY")
_date_    = set("date")
set century on
set date to ansi

_login = GETLOGIN()
IF _login $ "SUP,GAP"
  ON ERROR
ENDIF

=_CLOSE("W18","W22","W23","W24","Q_EMPL","_incons","_novpnd","q1","dtem13","dtem13w")

DO CLOSE_DATA

SET DELETED ON
SET ESCAPE OFF

wporc     = 0

flagp     = 0
flagn     = 0
flagt     = 0
flagi     = 0
flagv     = 0
issdiario = 0
sw        = 0
diaslab   = 0
hrslab    = 0
hrsrec    = 0
valorw    = 0
diastrans = 0
valst     = 0
dincap    = 0
dincvac   = 0
diasvac   = 0

vlrenfw   = 0
vlrinvw   = 0
issmen    = 0
destajo   = 0
diastem   = 0

nitw      = SPACE(10)
resp0     = SPACE(1)
tipow     = SPACE(1)

cecostw   = SPACE(8)

wfecha1   = ctod(' ')
wfecha2   = ctod(' ')

fecort    = date()

aa        = space(2)
mm        = space(2)
dd        = space(2)
mesw      = NTOC(MONTH(DATE()),2)

x         = 0
fin       = 0
liq       = 0
swt       = 0
swn       = 0
mcuadre   = 0
mdias0    = 0
mdias1    = 0
mdias2    = 0
mdias4    = 0
_repo1_   = 1
_repo2_   = 1

_get_step = GET_STEP(7," General ")

STORE 1 TO _vacacio_    && determina si revisa vacaciones o no
STORE 1 TO wl_primas    && Lista de liq de Prima Servicio
STORE 1 TO wl_pripro    && Lista de liq Prima Proyectada
STORE 'N' TO wdes,sn,sn1
STORE 2 TO winc

RELEASE _ccosto,wnit,mced, tipcontw
PUBLIC  _ccosto,wnit,mced, tipcontw

wnit      = " "

SELECT 0
_leninia  = 6

USE ncontrol SHARED NOUPDATE
*IF use_exc("NCONTROL",.F.,7)
  wsalmin    = salmin
  salmindiaw = ROUND(wsalmin/30,2)
  valtrans   = vlrst
  winicioano = inicioano
  mesw       = RIGHT(per_act,2)
  xano       = LEFT(inicioano,4)
  xano1      = STR(VAL(xano)-1,4)

  _ppen_     = porpension/4    && porcentaje de pension que aplica
                               && para el descuento en retefuente

  _leninia   = len(INICIOANO)

  wminret    = minret
  wexcl1     = excrfint           && porc excl xa salarios integrales
  wexcl2     = excrfnin           && porc excl xa salario no integral
  IF TYPE("por_rf_civ") = "N"
     wpor_rfc= por_rf_civ         && Porc RetFte para Contratos Civiles
  ELSE
     wpor_rfc= 0
  ENDIF

*ENDIF

*IF use_exc("USUARIOS",.F.,7)
=_CLOSE("USUARIOS","NCONTROL")
SELECT 0
USE USUARIOS AGAIN SHARED NOUPDATE
GO TOP

  SCATTER MEMVAR
  *set step on
  mliqprima  = (primas="S")
  mliqintces = (intces="S")
  mcnc_perem = TRAE_DATO('FLEX7SRH',1,'USUARIOS'+'PER_REMUN '+m.consec,'ALLTRIM(dato)')
  mconbasva1 = TRAE_DATO('FLEX7SRH',1,'USUARIOS'+'CONBASVARI'+'01','ALLTRIM(dato)')
  mconbasva2 = TRAE_DATO('FLEX7SRH',1,'USUARIOS'+'CONBASVARI'+'02','ALLTRIM(dato)')
*ELSE
*  RETURN
*ENDIF
USE

men_nit = "Digite el codigo del Negocio"

men_gru = "Seleccione el Grupo de Trabajadores,"+_c13+;
          "con ' * '  puede consultar"
men_cco = "Digite el Codigo del Centro de Costos"+_c13+;
          "Con ' * '  puede consultar"
men_pri = "S: Liquidar Prima de Serv. en esta liquidacin."+_C13+;
          "N: NO liquida prima de Servicio."+_C13+;
          "P: Liquida Prima de Servicio Solo sobre valores"+_C13+;
          "   de esta liquidacion.(NO Proyecta prima)"+_c13+;
          "V: Liquida Primas 'SOLAS' sin NOVEDADES DE"+_C13+;
          "   NOMINA."

men_pro = "S: Si debe proyectar prima"+_C13+;
          "N: NO proyectar, liquidar sobre acumulados"+_C13+;
          "L: Tomar dato del LISTADO de primas Proyectadas"

men_des = "Seleccione esta casilla para INCLUIR"+_C13+;
          "los conceptos Fijos en esta liquidac"

men_vac = "Seleccione esta casilla para verificar"+_C13+;
          "las solicitudes de  Vacaciones Legales"+_C13+;
          "e incluirlas en esta liquidacin"

men_ced = "Digite el cod del Trabajador que desea"+_C13+ ;
          "liquidar o deje  este campo EN  BLANCO"+_C13+;
          "para  liquidar todos  los trabajadores"+_C13+;
          "de este negocio !"

men_dig = "Digite los codigo de los usuario que grabaron" +_C13+;
          "los Tiempos y las novedades o deje este campo" +_C13+;
          "en Blanco para no FILTRAR la informacion."

men_suc = "Digite los codigo de la Sucursal/Agencia" +_C13+;
          "que desea procesar o deje este campo  en" +_C13+;
          "Blanco para procesar  todos los Trabaja-" +_C13+;
          "dores Activos de este Negocio."

men_dom = "Digite la cant de domingos"+_C13+;
          "que tiene este periodo."

men_fes = "Digite la cant de FESTIVOS"+_C13+;
          "que tiene este periodo."

men_per = "Digite el Tipo de Periodo"+_C13+;
          "que desea liquidar:"+_C13+;
          "  S:Semana    D:Decada "+_C13+;
          "  C:Catorcena Q:Quincena"+_C13+;
          "  M:Mes       K:Quin. Esp"+_C13+ ;
          "En blanco para todos."

men_tim = "Seleccione esta casilla para"+_C13+;
          "liquidar  NOMINA  solo a los"+_C13+;
          "empleados que tienen grabado"+_C13+;
          [registro(s) en "TIEMPOS.DBF"]

men_di_ = "Cantidad de dias maximo que debe"+_C13+;
          "liquidar a cada empleado."

men_inc = "Seleccione si desea incluir los pagos"+_C13+;
          "de incapacidades en este Proceso"

men_ces  = "Seleccione  si desea  incluir los pagos"+_C13+;
          "de Anticipo de Cesantia en este Proceso"

men_tra  = "Seleccione  si desea liquidar el Subisidio"+_C13+;
           "de Transporte por Calculo Automatico"

errornit  = .T.
borrarant = .F.

RELEASE wconsec
PUBLIC  wconsec

wconsec = SYS(3)
SET FUNCTION 5 TO wconsec
ktit    = " Liquidacion Nomina "+IIF(mtipo='D',"Definitiva ","Tentativa ")
wcolor  = IIF(mtipo='D',5,1)

RELEASE WINDOW consult4
DO DEF_WIND WITH "4",'Procesando ...'

   DEFINE WINDOW w_liqnom2 ;
     FROM SROW()-10,SCOL()-39 ;
     TO SROW()-2,SCOL()-8 ;
     SHADOW ;
     NOGROW ;
     COLOR SCHEME 8 ;
     FONT "Courier New",9  ;
     TITLE " Prima Servicio "


STORE 0 TO _perant_
STORE 1 TO _descuen_



#REGION 0
REGIONAL m.currarea, m.talkstat, m.compstat

IF SET("TALK") = "ON"
	SET TALK OFF
	m.talkstat = "ON"
ELSE
	m.talkstat = "OFF"
ENDIF
m.compstat = SET("COMPATIBLE")
SET COMPATIBLE FOXPLUS

m.rborder = SET("READBORDER")
SET READBORDER ON

m.currarea = SELECT()


*       *********************************************************
*       *                                                         
*       *             Windows Definiciones de ventana             
*       *                                                         
*       *********************************************************
*

IF NOT WEXIST("w_liqnom") ;
	OR UPPER(WTITLE("W_LIQNOM")) == "W_LIQNOM.PJX" ;
	OR UPPER(WTITLE("W_LIQNOM")) == "W_LIQNOM.SCX" ;
	OR UPPER(WTITLE("W_LIQNOM")) == "W_LIQNOM.MNX" ;
	OR UPPER(WTITLE("W_LIQNOM")) == "W_LIQNOM.PRG" ;
	OR UPPER(WTITLE("W_LIQNOM")) == "W_LIQNOM.FRX" ;
	OR UPPER(WTITLE("W_LIQNOM")) == "W_LIQNOM.QPR"
	DEFINE WINDOW w_liqnom ;
		AT  0.000, 0.000  ;
		SIZE 35.385,117.600 ;
		TITLE "SIE7E" ;
		FONT "MS Sans Serif", 8 ;
		FLOAT ;
		NOCLOSE ;
		NOMINIMIZE ;
		SYSTEM ;
		COLOR RGB(,,,192,192,192)
	MOVE WINDOW w_liqnom CENTER
ENDIF


*       *********************************************************
*       *                                                         
*       *         LIQNOM/Windows Distribucin de pantalla         
*       *                                                         
*       *********************************************************
*

#REGION 1
IF WVISIBLE("w_liqnom")
	ACTIVATE WINDOW w_liqnom SAME
ELSE
	ACTIVATE WINDOW w_liqnom NOSHOW
ENDIF
@ 0.000,0.000 TO 3.769,117.600 ;
	PATTERN 1 ;
	PEN 1, 8 ;
	COLOR RGB(,,,0,0,128)
@ 0.538,42.600 SAY "LIQUIDACION DE NOMINA" ;
	FONT "Arial", 10 ;
	STYLE "BT" ;
	COLOR RGB(255,255,0,,,,)
@ 0.385,100.200 SAY "LIQNOM2.05A" ;
	FONT "Arial", 9 ;
	STYLE "IT" ;
	COLOR RGB(255,255,255,,,,)
@ 4.846,10.200 SAY "Grupo Trab:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	COLOR RGB(0,0,128,,,,)
@ 6.308,10.600 SAY "Codigo Ag.:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 7.769,7.400 SAY "Cod. Negocio:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	COLOR RGB(0,0,128,,,,)
@ 9.231,6.200 SAY "Cod. Cencosto:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 10.692,5.400 SAY "Cod Trabajador:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 16.538,6.600 SAY "Primas de Servicio:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 16.538,84.400 SAY "F.Corte:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 15.923,4.800 TO 30.000,110.600 ;
	PEN 1, 8 ;
	COLOR RGB(128,128,128,,,,)
@ 29.923,4.800 TO 29.923,110.600 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 15.923,110.400 TO 30.000,110.400 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.692,4.400 SAY "Periodo Nominal:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 12.385,67.800 SAY "-" ;
	FONT "MS Sans Serif", 12 ;
	STYLE "BT"
@ 12.692,35.000 SAY "Lapso Nomina:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 12.385,106.400 SAY "-" ;
	FONT "MS Sans Serif", 12 ;
	STYLE "BT"
@ 12.692,86.400 SAY "Per S.Soc:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 14.154,37.000 SAY "Periodicidad:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 14.231,56.800 SAY "Domingos:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 14.308,74.000 SAY "Festivos:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 14.308,92.800 SAY "Dias:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 18.231,11.000 SAY "Incapacidades:" ;
	PICTURE "@J" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 30.923,28.600 TO 34.692,88.800 ;
	PEN 1, 8 ;
	COLOR RGB(128,128,128,,,,)
@ 34.615,28.600 TO 34.615,88.800 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 30.923,88.600 TO 34.692,88.600 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 28.000,4.800 TO 28.000,110.600 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 27.923,5.200 TO 27.923,110.600 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 2.000,44.600 GET wc_tipo ;
	SIZE 1.000,23.333 ;
	DEFAULT " " ;
	FONT "Arial", 9 ;
	STYLE "B" ;
	PICTURE "@K!I" ;
	WHEN .F. ;
	COLOR ,RGB(255,255,0,0,0,128)
@ 4.846,25.200 GET wgru ;
	SIZE 1.000,2.857 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K !!!" ;
	WHEN FILE('nmgrupo1.dbf') AND ABRIR0('nmgrupo1',0) AND RECC('nmgrupo1') > 0 AND w_gru() ;
	VALID v_grupnom(wgru,'wgru2',.T.) ;
	MESSAGE _mens(men_gru) ;
	COLOR ,RGB(,,,255,255,255)
@ 4.846,31.200 GET wgru2 ;
	SIZE 1.000,57.143 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K" ;
	WHEN .F. ;
	COLOR ,RGB(,,,255,255,255)
@ 6.308,25.200 GET wsuc ;
	SIZE 1.000,2.857 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K !!!" ;
	WHEN w_suc() ;
	VALID v_suc() ;
	MESSAGE _mens(men_suc) ;
	COLOR ,RGB(,,,255,255,255)
@ 6.308,31.200 GET wnsc ;
	SIZE 1.000,57.143 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K" ;
	WHEN .F. ;
	COLOR ,RGB(,,,255,255,255)
@ 7.769,25.200 GET nitw ;
	SIZE 1.000,10.000 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K!" ;
	WHEN EMPTY(wgru) ;
	VALID ES_NIT() ;
	MESSAGE _mens(men_nit) ;
	COLOR ,RGB(,,,255,255,255)
@ 7.769,42.800 GET wraz ;
	SIZE 1.000,48.857 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K" ;
	WHEN .F. ;
	COLOR ,RGB(,,,255,255,255)
@ 9.231,25.200 GET wcco ;
	SIZE 1.000,8.143 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K!" ;
	WHEN EMPTY(wgru) AND !EMPTY(nitw) AND ABRIR('cencosto',1) AND SEEK(nitw) ;
	VALID v_cco() ;
	MESSAGE _mens(men_cco) ;
	COLOR ,RGB(,,,255,255,255)
@ 9.231,42.800 GET wncc ;
	SIZE 1.000,48.857 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K" ;
	WHEN .F. ;
	COLOR ,RGB(,,,255,255,255)
@ 10.692,25.200 GET wced ;
	SIZE 1.000,8.143 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K!" ;
	WHEN EMPTY(wgru) ;
	VALID val_ced() ;
	MESSAGE _mens(men_ced) ;
	COLOR ,RGB(,,,255,255,255)
@ 10.692,38.200 GET wcnt ;
	SIZE 1.000,2.000 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K!" ;
	WHEN !EMPTY(wced) ;
	VALID val_cnt() ;
	COLOR ,RGB(,,,255,255,255)
@ 10.692,42.800 GET wnom ;
	SIZE 1.000,48.857 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K" ;
	WHEN .F. ;
	COLOR ,RGB(,,,255,255,255)
@ 12.615,25.200 GET wpernom ;
	SIZE 1.000,6.000 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K!" ;
	WHEN w_pernom() ;
	VALID v_pernom() AND _enable() ;
	MESSAGE _mens("Seleccion el Periodo Nominal"+CHR(13)+[Con  *  Consulta periodos Activos]) ;
	COLOR ,RGB(,,,0,255,255)
@ 12.692,52.800 GET wfecha1 ;
	SIZE 1.000,10.000 ;
	DEFAULT {  /  /  } ;
	FONT "Courier New", 8 ;
	PICTURE "@K 9999.99.99" ;
	WHEN .f. ;
	COLOR ,RGB(,,,0,255,255)
@ 12.692,69.600 GET wfecha2 ;
	SIZE 1.000,10.000 ;
	DEFAULT {  /  /  } ;
	FONT "Courier New", 8 ;
	PICTURE "@K 9999.99.99" ;
	WHEN .F. ;
	COLOR ,RGB(,,,0,255,255)
@ 12.692,99.600 GET anow ;
	SIZE 1.000,4.000 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K 9999" ;
	WHEN .F. ;
	COLOR ,RGB(,,,0,255,255)
@ 12.692,108.400 GET mesw ;
	SIZE 1.000,2.000 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K 99" ;
	WHEN .F. ;
	COLOR ,RGB(,,,0,255,255)
@ 14.154,52.800 GET period ;
	SIZE 1.000,1.143 ;
	DEFAULT " " ;
	FONT "Courier New", 8 ;
	PICTURE "@K !" ;
	WHEN .f. ;
	COLOR ,RGB(,,,0,255,255)
@ 14.231,69.600 GET wdom ;
	SIZE 1.000,1.143 ;
	DEFAULT 0 ;
	FONT "Courier New", 8 ;
	PICTURE "@K 9" ;
	COLOR ,RGB(,,,0,255,255)
@ 14.308,85.200 GET wfes ;
	SIZE 1.000,1.143 ;
	DEFAULT 0 ;
	FONT "Courier New", 8 ;
	PICTURE "@K 9" ;
	COLOR ,RGB(,,,0,255,255)
@ 14.308,99.600 GET wdi_ ;
	SIZE 1.000,2.000 ;
	DEFAULT 0 ;
	FONT "Courier New", 8 ;
	PICTURE "@K 99" ;
	VALID _enable() ;
	COLOR ,RGB(,,,0,255,255)
@ 16.308,29.400 GET wl_primas ;
	PICTURE "@^ NO Calcular;Calcular sin Proyeccion;Calcular con Proyeccion;Parcialmente (solo estas novedades);Independientes sin Proyeccion;Independientes con Proyeccion" ;
	SIZE 1.538,43.667 ;
	DEFAULT "NO Calcular" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN mliqprima ;
	VALID v_primas()
@ 16.538,94.400 GET fecort ;
	SIZE 1.000,10.000 ;
	DEFAULT {  /  /  } ;
	FONT "Courier New", 8 ;
	PICTURE "@K 9999.99.99" ;
	WHEN wl_primas = 3 OR wl_primas = 6 ;
	COLOR ,RGB(,,,255,255,255)
@ 18.000,29.400 GET winc ;
	PICTURE "@^ NO liquidar ;Solo las de este Periodo;Calcular totalmente" ;
	SIZE 1.538,43.667 ;
	DEFAULT "NO liquidar " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID _enable()
@ 20.308,9.600 GET _perant_ ;
	PICTURE "@*C Calcular Devengos Per Anterior" ;
	SIZE 1.308,34.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 21.846,9.600 GET _descuen_ ;
	PICTURE "@*C Liquidar Conceptos Fijos" ;
	SIZE 1.308,27.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 23.385,9.600 GET _vacacio_ ;
	PICTURE "@*C Liquidar Vacaciones Disfrutadas" ;
	SIZE 1.308,35.000 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 24.923,9.600 GET _antces_ ;
	PICTURE "@*C Liquidar Anticipos de Cesantias" ;
	SIZE 1.308,34.167 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 21.846,57.600 GET _traut_ ;
	PICTURE "@*C CalcularTransporte Legal" ;
	SIZE 1.308,28.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 23.385,57.600 GET _pagar_ ;
	PICTURE "@*C Liquidar Prestamos - Intereses" ;
	SIZE 1.308,33.000 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 24.923,57.600 GET _segsoc_ ;
	PICTURE "@*C Calcular Seguridad social" ;
	SIZE 1.308,28.500 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 24.923,92.600 GET _segsoc1_ ;
	PICTURE "@*C Acum Mes" ;
	SIZE 1.308,14.167 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN _segsoc_ = 1 ;
	VALID _enable()
@ 26.462,57.600 GET _lprod_ ;
	PICTURE "@*C Liquidacion de Productividad" ;
	SIZE 1.308,32.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 31.846,34.800 GET wb_sal ;
	PICTURE "@*HN \\\<Procesar;\<Salir;\\Para\<metros" ;
	SIZE 1.769,12.167,1.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID _3hk0z7j1m()
@ 28.231,57.600 GET _repo1_ ;
	PICTURE "@*C Visualizar Reporte" ;
	SIZE 1.308,21.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 28.231,9.600 GET _repo2_ ;
	PICTURE "@*C Reportar Inconsistencias" ;
	SIZE 1.308,28.000 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 33.692,99.000 GET wconsec ;
	SIZE 1.000,10.200 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	PICTURE "@K" ;
	WHEN .F. ;
	COLOR ,RGB(0,0,128,192,192,192)
@ 28.462,91.600 GET w7_neto ;
	SIZE 1.000,13.167 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "9999,999,999" ;
	WHEN .f. ;
	COLOR ,RGB(,,,255,255,255)
@ 26.385,9.600 GET _retfte_ ;
	PICTURE "@*C Liquidar Retencion en la Fuente" ;
	SIZE 1.308,34.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	VALID _enable()
@ 21.846,42.400 GET _descuen1_ ;
	PICTURE "@*C Ac-Mes" ;
	SIZE 1.308,11.500 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN _descuen_ = 1 ;
	VALID _enable() ;
	MESSAGE _mens("Acumulado Mes")
@ 20.385,57.600 GET _audit_ ;
	PICTURE "@*C Informe de Auditoria" ;
	SIZE 1.308,23.500 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN FILE("LIQNOMAU.FXP") ;
	VALID _enable() ;
	DISABLE

IF NOT WVISIBLE("w_liqnom")
	ACTIVATE WINDOW w_liqnom
ENDIF

READ CYCLE MODAL

RELEASE WINDOW w_liqnom
SELECT (m.currarea)


#REGION 0

SET READBORDER &rborder

IF m.talkstat = "ON"
	SET TALK ON
ENDIF
IF m.compstat = "ON"
	SET COMPATIBLE ON
ENDIF


*       *********************************************************
*       *                                                         
*       *            LIQNOM/Windows Cdigo de limpieza            
*       *                                                         
*       *********************************************************
*

#REGION 1
****************************************************
*       AREA DE PROCEDIMIENTOS Y FUNCIONES         *
****************************************************



*       *********************************************************
*       *                                                         
*       *  LIQNOM/Windows Procedimientos y funciones de soporte   
*       *                                                         
*       *********************************************************
*

#REGION 1
PROCEDURE _procesar

      IF ABRIR0("EMPRESAS",1) AND !EMPTY(nitw) AND ;
         SEEK (nitw,"empresas") AND ;
         empresas.estado = "A"

         DO rev_preact WITH nitw
         SET FUNC 10 TO nitw
         WAIT WINDOW "Liquidando : "+ALLTRIM(nitw) NOWAIT
         DO grabproc WITH "LiqNom:"+mtipo+nitw+" "+wconsec,"A"
      ELSE
         WAIT WINDOW "Liquidando : "+ALLTRIM(wgru) NOWAIT
         DO grabproc WITH "LiqNom:"+mtipo+wgru+" "+wconsec,"A"
      ENDIF

      IF ABRIR0("CONCEPTO",1)
         mcon=LEN(codigo)
      ELSE
         LOOP
      ENDIF

      STORE 1    TO h100w,;
                    hdesw,;
                    hfesw
      STORE 1.25 TO h125w
      STORE 1.35 TO h135w
      STORE 1.75 TO h175w
      STORE 2    TO h200w
      STORE 2.25 TO h225w
      STORE 2.35 TO h235w
      STORE 2.75 TO h275w
      STORE 0.35 TO h035w

      STORE 1.75 TO h200N    && AJUSTES NUEVA LEY
      STORE 2.00 TO h225N    && LABORAL DR. URIBE
      STORE 2.10 TO h235N    && ENERO 2003
      STORE 2.50 TO h275N    &&

*      IF wfecha2 >= {^2003-04-01}
         STORE 1.75 TO h200w      &&
         STORE 2.00 TO h225w      &&  AJUSTES NUEVA LEY
         STORE 2.10 TO h235w      &&  LABORAL DR. URIBE
         STORE 2.50 TO h275w      &&
*      ELSE
*         STORE 2.00 TO h200w      &&
*         STORE 2.25 TO h225w      &&  AJUSTES NUEVA LEY
*         STORE 2.35 TO h235w      &&  LABORAL DR. URIBE
*         STORE 2.75 TO h275w      &&
*      ENDIF

      =_CLOSE("q_subcon","subcon")

      IF !ABRIR0("empresas",1)
         WAIT WINDOW 'NO FUE POSIBLE USAR: EMPRESAS.DBF' TIMEOUT 120
         SET CONF OFF
         = estableconf()
         RETURN
      ENDIF

      *w_empresa = buscar(nitw,.T.,.T.)
      IF !EMPTY(nitw) AND SEEK(nitw)
         STORE razon           TO mrazon
         STORE LEFT(tipo,1)    TO tipow
         STORE inddoming       TO inddominw
         STORE hrsjornada      TO horasperw
         STORE jornadia        TO hrsdiaw
         STORE vlrsubtran      TO valtrans
         STORE hrsdomi         TO hrsdomiw
         STORE hrsfest         TO hrsfesw
         STORE indextesp       TO estespw
         STORE indcosto        TO indcosw
         STORE clase           TO clasew
         STORE indiss          TO indiss1w
         STORE subtdomf        TO st_domw
         STORE GETLOGIN()      TO mdg
         STORE vlrmin*wsalmin  TO _min
         STORE vlrmax*wsalmin  TO _max
         STORE hrsmes          TO whrsmes
         STORE separacion      TO wnvaleyneg
         STORE .F.             TO errornit
         STORE min_garan       TO ng_mingarw
         STORE FORMPAG         TO formpagw
         STORE ENE31           TO ene31w
         STORE MAR31           TO mar31w
         STORE MAY31           TO may31w
         STORE JUL31           TO jul31w
         STORE AGO31           TO ago31w
         STORE OCT31           TO oct31w
         STORE DIC31           TO dic31w
         STORE FEB30           TO feb30w
      ELSE
         IF EMPTY(wgru)
            STORE .T. TO errornit
            WAIT WINDOW "Negocio NO existe !"
         ELSE
            STORE .F.             TO errornit
         ENDIF
      ENDIF


**** VALIDAR MATRICULA DE CONCEPTOS X NEGOCIOS

rta      = "S"
errormes = .T.

mfec1    = wfecha1  &&SUBS(wfecha1,1,2)+SUBS(wfecha1,4,2)+SUBS(wfecha1,7,2)
mfec2    = wfecha2  &&SUBS(wfecha2,1,2)+SUBS(wfecha2,4,2)+SUBS(wfecha2,7,2)

WAIT WINDOW "Liquidando : "+ALLTRIM(nitw)+".." NOWAIT
DO grabproc WITH "LiqNom :"+nitw+dtos6(mfec1)+dtos6(mfec2),"A"
DO grabproc WITH "LiqNom :"+nitw+" "+period+STR(wdom,1)+STR(wfes,1),"B"

IF mliqprima AND mtipo="D"
   DO grabproc WITH "LiqNom :"+nitw+" "+sn+sn1+dtos6(fecort),"C"
ENDIF

=_CLOSE("nmregco","ncontrol","usuarios",'DTEM13')

=ABRIR0("CONCEPTO",1) AND ABRIR("empleado","indemp")

SET TALK OFF
SELECT empleado.*, trae_fec_sp(nitemple,ncontrato) AS fecret1 ;
  FROM empleado ;
 WHERE estado$"aAL" and EMPTY(estadoliq) ;
   AND fecing <= DTOS(wfecha2)  ;
   AND (EMPTY(period) OR formpago = period) ;
   AND (EMPTY(wced)   OR nitemple = wced)  ;
   AND (EMPTY(wsuc)   OR codage   = wsuc)  ;
   AND (EMPTY(nitw)   OR nitempre = nitw)  ;
   AND (EMPTY(wcco)   OR ccosto   = wcco)  ;
   AND (EMPTY(wgru)   OR ;
        nitempre+codage IN (SELECT negoci+sucurs ;
                              FROM nmgrupo2 ;
                             WHERE codigo=wgru ;
                               AND estado='ACT') OR ;
        nitempre IN (SELECT negoci ;
                       FROM nmgrupo2 ;
                      WHERE codigo=wgru ;
                        AND EMPTY(sucurs) ;
                        AND estado='ACT')) ;
  INTO CURSOR q_empl ;
 ORDER BY nitempre,nitemple,ncontrato
SET TALK OFF

IF _wuser = 'SUP' AND _repo2_ = 1
   ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
   ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN
   BROWSE NORMAL  TIMEOUT 25 NOMO NOAP NODE TITLE 'Trabajadores Seleccionados' ;
      FIEL codage:H="Age",nitemple,ncontrato:h="Cnt", ;
           tipcont:H="Tip",nombre,fecing,fhasta,fecret1, ;
           estado:H="Est", fec_up1,fec_up2:H="Nom_Cub" , ;
           nitempre, NEGOCIO=TRAE_RAZ(nitempre), hrapag, ;
           formpago, tippag,integral,subtran,ccosto
   ON KEY LABEL ENTER
   ON KEY LABEL F8
   IF LASTKEY() = 27
      *RELEASE WINDOW w_liqnom
      RELEASE WINDOW w_liqnom2
      RETURN
   ENDIF
ENDIF

w_audita = (!EMPTY(wced) AND MENSAJE('Activar Auditoria Liquidacion ?'))

SELECT 0
IF mtipo='D'
   USE dtem13 ORDER 1 AGAIN

   * ------------------------------------------- *
   *        Automaticos  de acumulacion          *
   * ------------------------------------------- *
   IF wautomatic AND !EMPTY(nitw) AND SEEK(nitw)
      DO WHILE liqempre =  nitw
         =_mens("Verificacion 01 ....")
         DO CASE
            CASE liqestado='B'
                 REPLACE liqestado WITH 'A'
            CASE liqestado='F'
                 REPLACE liqestado WITH 'H'
            CASE liqestado='H'
                 REPLACE liqestado WITH 'T'
            CASE liqestado='H'
                 REPLACE liqestado WITH 'T'
            CASE liqestado$'GT'
                 DELETE NEXT 1
         ENDCASE
         SKIP
      ENDDO
      WAIT CLEAR
   ENDIF
ELSE
   WAIT WINDOW "Liquidando : "+ALLTRIM(nitw)+"....." NOWAIT
   USE dtem13w  ALIAS dtem13 ORDER 1 AGAIN
   IF EMPTY(wgru) AND !EMPTY(nitw) AND SEEK(nitw)

      DO WHILE !EOF() AND liqempre = nitw
         IF liqestado =[A] AND dg # _wuser
            EXIT
         ENDIF
         SKIP
      ENDDO
      IF liqempre = nitw
         borrarant = MENSAJE('Borra la liq Tent de otros usuarios y de este Negocio?')
      ENDIF

      DO REPL_EST

   ELSE  && No esta vacio el grupo

   ENDIF
ENDIF

WAIT WINDOW "Liquidando : "+ALLTRIM(nitw)+"......" NOWAIT

IF EMPTY(wgru) AND ABRIR("noved",1) AND SEEK(nitw)
   DO WHILE novempre=nitw
      IF novestado = "a"
         =_mens("Verificacion 02 ....")
         REPLACE novestado WITH "A"
      ENDIF
      SKIP
   ENDDO
   WAIT CLEAR
   =_CLOSE("noved")

ELSE

   * RECUPERAMOS NOVEDADES PREACTIVAS
   DO REC_NOVPRE
ENDIF

SELECT q_empl
GO TOP
=SEEK(nitempre+nitemple+ncontrato,"empleado")

IF _GET_STEP AND GET_STEP(5," Buscando Cnts ")
   SET STEP ON
ENDIF

DO WHILE !EOF()

   IF SEEK(nitempre,"empresas")
      nitw = nitempre
      SELECT empresas
      wraz = razon
      SHOW GET nitw
      SHOW GET wraz

      STORE LEFT(tipo,1)    TO tipow
      STORE inddoming       TO inddominw
      STORE hrsjornada      TO horasperw
      STORE jornadia        TO hrsdiaw
      STORE vlrsubtran      TO valtrans
      STORE hrsdomi         TO hrsdomiw
      STORE hrsfest         TO hrsfesw
      STORE indextesp       TO estespw
      STORE indcosto        TO indcosw
      STORE clase           TO clasew
      STORE indiss          TO indiss1w
      STORE subtdomf        TO st_domw
      STORE GETLOGIN()      TO mdg
      STORE vlrmin*wsalmin  TO _min
      STORE vlrmax*wsalmin  TO _max
      STORE hrsmes          TO whrsmes
      STORE separacion      TO wnvaleyneg
      STORE .F.             TO errornit
      STORE min_garan       TO ng_mingarw

      SELECT q_empl
   ENDIF

   SELECT q_empl
   IF SEEK(nitempre+nitemple+ncontrato,"empleado")
      _reg_empl = RECNO("empleado")
   ELSE
      _reg_empl = 0
   ENDIF
   SELECT q_empl
   whrsmes  = IIF(TYPE("hrsmes")="N" AND hrsmes>0, hrsmes,whrsmes)

   IF LASTKEY()=27
      SET CONF OFF
      = estableconf()
      RETURN
   ENDIF

   fecretw    = fecret1

   IF estado $ "AaL" AND nitempre=nitw AND ;
      (EMPTY(fecretw) OR fecretw >= DTOS(wfecha1) OR estado='L' OR tipcont='A')
      *AND (mtipo='T' .OR. rblokado(7))

      * ------------------------- *
      * Validaciones para el pago *
      IF hrapag = 0 AND clacont # 'C'
         _men = TRIM(NOMBRE)+_C13+" Tiene Basico mensual: $0/00="
         =_mens(_men,.t.,10)
         SKIP
         LOOP
      ENDIF

      nitemprew = nitempre
      nitemplew = nitemple
      nombrew   = nombre
      alfabw    = nombre
      catissw   = catiss
      subtranw  = subtran

      fecingw   = turndate(fecing)

      tipcontw  = tipcont
      clacontw  = clacont
      tippagw   = tippag
      hracobw   = hracob
      hrapagw   = IIF(fecvigus>mfec2,hrapag1,hrapag)
      hrapag1w  = hrapag1
      fecvigusw = fecvigus
      conbasicow= IIF(!EMPTY(conbasico),conbasico,m.conh100)
      indretw   = indret
      vlrretw   = vlrret
      contw     = ncontrato
      oficiow   = codoficiom
      intw      = integral
      _ccosto   = ccosto
      codagew   = codage
      min_garw  = IIF(ng_mingarw="S",empleado.min_garan,0)

      manualw   = "N"
      manret    = "N"
      manpri    = "N"
      _embali   = "N"

      IF EMPTY(fecretw)
         mfec3  = fecort                               &&str(year(fecort),4,0) + Str(month(fecort),2,0) + Str(day(fecort),2,0)
      ELSE
         mfec3  = MIN(fecort,STOD(fecretw))
      ENDIF
      mfec4     = Stod(str(year(fecort),4,0)+'0101')   &&str(year(fecort),4,0) + '0101'
      mfec5     = MAX(STOD(fec_up2),STOD(fecing)-1)

      mtotsal   = acumsalar1
      mprima    = ROUND(mtotsal/12,0)-primjunpag
      mintces   = sdoprovint
      mpriant   = sdoprovpr
      msdoces   = sdoprovces

      IF !EMPTY(wgru) AND mtipo="T"
         DO REPL_EST1 WITH nitemprew,contw
      ENDIF

      mfec0     = IIF(fecingw<mfec4, mfec4, fecingw)
      mdias0    = MAX(mfec1-mfec0-1,0)
      mdias1    = MAX(mfec2-mfec1+1,0)   && Dias del Periodo de Liquidacion
      mdias2    = MAX(mfec3-mfec2,0)     && Dias para proyeccion de Prima S.
      mdias5    = MAX(mfec3-mfec5,0)     && Dias para proyeccion de Prima VS fec_up2
      IF !EMPTY(fecretw) AND STOD(fecretw) < mfec1  &&MAX(mfec2,mfec3)
         mdias2 = 0
      ENDIF

      IF fecing <= DTOS(wfecha1) AND 0 < wfes
         festivos  = wfes
      ELSE
         IF ABRIR0('tabgen10',1) AND SEEK('FE')
*           COUNT TO wfes WHILE tipfec = "FE" ;
                  FOR BETWEEN(datfec,fecingw,wfecha2)
         ENDIF
         SELECT   q_empl    &&empleado
         festivos = wfes
      ENDIF

      domingos = wdom

      diaslab  = 0
      diasnlab = 0
      dincap   = 0
      diasvac  = 0
      hrslab   = 0
      hrsrec   = 0
      totdev   = 0
      devengow = 0
      ajus_dtr = 0

      llave1   = nitemprew + nitemplew

      ** validar los registros de vacaciones si tiene prendido el switch
      ** de vacaciones


      *******************************
      *     V A C A C I O N E S     *
      *  I N C A P A C I D A D E S  *
      * A N T  -  C E S A N T I A S *
      *******************************

      STORE  0  TO dincap, diasvac,dincvac, flagi, flagt
      STORE .F. TO wprocinc,wprocvac,wprocant

      IF (indcosw $ "234")
         ccostow = _ccosto    &&TRAE_DATO('empleado',6,nitemplew+contw,'ccosto')
      ELSE
         ccostow = SPACE(8)
      ENDIF

      IF winc > 1
         DO LiqNomIn WITH nitemprew, nitemplew, contw
      ENDIF

      IF _vacacio_ = 1
         flagv = 0
         DO LiqNomVc WITH nitemprew, nitemplew, contw
      ENDIF

      IF _antces_ = 1 AND clacontw # 'C'
         DO LiqNomAc WITH nitemprew,nitemplew,contw,msdoces,mintces
      ENDIF

      *******************************
      *     N O V E D A D E S       *
      *******************************
      liqmultiw = 0.00
      valorw    = 0.00
      flagn     = 0
      hrsrec    = 0
      flagp     = 0

      =_CLOSE("noved")
      SELECT 0
      IF use_exc("NOVED",.F.,7)
         SET ORDER TO 1

         =SEEK(llave1)
      ENDIF

      nitempre2 = nitw  &&novempre
      nitemple2 = nitemplew

      IF (indcosw $ "234") AND !EMPTY(novcencos)
         ccostow = novcencos
      ELSE
         ccostow = SPACE(8)
      ENDIF

      _conbasico = .F.
      IF sn #'V'      && Ind de Prima SOLA
         DO LiqNomNv WITH nitemprew, nitemplew, contw
         IF _descuen_ = 1
            DO LiqNomCf WITH nitw,nitemplew,contw, .T.
         ENDIF
      ENDIF

      * * * * * * * * * * * * * * * * * * *
      * Liquida Festivo y dominical si ha *
      * tenido pago de horas por novedad. *
      * * * * * * * * * * * * * * * * * * *
*SET STEP ON
      IF (festivos+domingos>0)

*      SET STEP ON
         worigen = "AU"
         whrsfes = festivos * hrsfesw
         hrslab = f_hrslab(nitemplew,contw)

         IF festivos > 0
            valorw = ROUND(hrapagw * whrsfes,0)
            DO add_dtem WITH nitemprew,nitemplew,m.con100f,h100w,;
               hrapagw,whrsfes,valorw,tippagw,mcuadre,mesw,contw,;
               alfabw,ccostow,hdesw,;
               clasew,dtos(wfecha1),dtos(wfecha2),xano

            STORE devengow + valorw TO devengow
            SELECT concepto
            totdev = totdev + si_iss(m.con100f,valorw,indiss1w)

            IF st_domw #"N"
               hrslab   = hrslab + whrsfes
               ajus_dtr = ajus_dtr + whrsfes
            ENDIF

         ENDIF

         IF domingos > 0
            IF _get_step AND GET_STEP(5,'Dominical:'+nitemplew)
               SET STEP ON
            ENDIF
            whrsdom  = domingos * hrsdomiw
            wdomprop = ROUND(hrslab*whrsdom/horasperw,2)
*           wdomprop = ROUND(((hrslab-(dincap+diasvac*hrsdomiw)) * whrsdom) / ((wdi_-domingos-festivos)*hrsdiaw),IIF(DATE()>{^2005-04-10},2,0))
            wdomprop = MIN(wdomprop,whrsdom)

            IF wdomprop > 0
               valorw  = hrapagw * wdomprop
               DO add_dtem WITH Nitemprew,nitemplew,m.con100d,h100w,;
                  hrapagw,wdomprop,valorw,tippagw,mcuadre,mesw,contw,;
                  alfabw,ccostow,hdesw,clasew,dtos(wfecha1),dtos(wfecha2),xano

               STORE devengow + valorw TO devengow
               SELECT concepto
               totdev = totdev + si_iss(m.con100d,valorw,indiss1w)

               IF st_domw #"N"
                  hrslab   = hrslab + wdomprop
                  ajus_dtr = ajus_dtr + wdomprop
               ENDIF

            ENDIF
         ENDIF
      ENDIF

      * 2010.12.28
      * Sacamos del IF anterior para que aplique siempre
      DO LiqNomCn WITH nitw,nitemplew,contw

      *SET STEP ON
      IF _lprod_ = 1 AND ;
         (flagn + flagt + flagi > 0 )
         DO Liq_Prod WITH nitw, nitemplew, contw
      ENDIF
      **************************************************
      *      LIQUIDACION DE NOVEDADES PENDIENTES       *
      *     SUBSIDIO FAMILIAR  /  SALDOS EN ROJO       *
      **************************************************
      IF (flagn + flagt + flagi > 0 )
         DO LiqNomNP WITH nitw, nitemplew, contw
      ENDIF

      **************************************************
      *     CALCULO DE DIAS LABORADOS (DIASLAB)        *
      **************************************************
*     _whi_ = 'codemp+contrato=nitemplew+contw FOR ano+mes=xano+mesw'
      IF (flagn+flagt+flagi > 0 OR wprocinc OR wprocvac OR SN= 'V') AND ;
         f_sel_nmac(nitempleW,contw,xano,mesw)

*         STORE (hrslab / hrsdiaw) + 0.49 TO diastem
*         STORE ROUND(diastem,0)          TO diaslab

          RELEASE diastem, diaslab
          PUBLIC  diastem, diaslab
          STORE ROUND(hrslab/hrsdiaw,2)   TO diastem,diaslab
         **************************************************
         *     S U B S I D I O    T R A N S P O R T E     *
         **************************************************
         IF !clacontw$'CSLE' AND  ;
            manualw = "N" AND _traut_= 1
            DO LiqNomST WITH nitw,nitemplew,contw
         ENDIF

         *******************************************************
         *        PRESTAMOS Y OTROS DESCUENTOS AUTOMATICOS     *
         *******************************************************
         * INDICADOR: V:VALOR, P:PORCENTAJE, C:CUOTAS A:AHORRO *
         *            1:Prop diasISS   2:Prop ROUND(diasIss)   *
         *******************************************************
         STORE 0 TO valorw

         =_CLOSE("descuent")
         SELECT 0

*        IF ((flagn+flagi >0  AND devengow # 0 ) OR sn$'SVP') AND _descuen_ = 1
         IF (devengow # 0  OR sn$'SVP') AND _descuen_ = 1
            DO LiqNomCf WITH nitw,nitemplew,contw,.F.
            * Ahora Conceptos Fijos x Negocio
           * if _wuser='SUP'
           *    set step on
           * endif
         ENDIF

         * ---------------------------------------------------- *
         *     ------     LIQUIDACION DE PRIMA      ------      *
         *     MPRIMA: PRIMA BASE REAL    MDIAS0:Dias anterior  *
         *     MPRIM0: PRIMA PAGO ACTUAL  MDIAS1:Dias per actual*
         *     MPRIM1: PRIMA PROYECTADA   MDIAS2:Dias proyectad *
         * ---------------------------------------------------- *
         STORE 0 TO mprim0, mprim0, mprim1
         IF sn $ "SPV" AND !(tipcontw $ 'A') AND !(clacontw $ 'CSLE' ) AND flagp = 0
            IF sn=[V] AND flagn + flagi = 0 AND mfec5 > fecingw
               mdias1 = 0
               mdias2 = mdias5  &&(mfec3 - mfec1) + 1
            ENDIF
            DO LiqNomPS WITH nitw,nitemplew,contw
         ENDIF

         **************************************
         *     PAGO DE INTERES DE CESANTIA    *
         **************************************
         IF flagn >= 0 AND mliqintces  AND mintces > 0 AND clacontw # "C" AND ;
            tipcontw # "A"

*           SET STEP ON
            worigen = "PV"
            DO add_dtem WITH nitw,nitemplew,m.conintant,hracobw,hrapagw,;
               0,mintces,tippagw,mcuadre,;
               "12",contw,alfabw,ccostow,liqmultiw,clasew,dtos(wfecha1),;
               dtos(wfecha2),xano1
    *           REPLACE empleado.fecultces WITH STOD6(xano1+"1230")
         ENDIF

         **************************************
         *  PAGO DE PRIMA PENDTE ANO ANTERIOR *
         **************************************
         IF flagn = 1 AND mpriant # 0 AND clacontw # "C" AND tipcontw # "A"
            worigen = "PV"
            DO add_dtem WITH nitw,nitemplew,m.conprimaa,hracobw,hrapagw,;
               0,mpriant,tippagw,mcuadre,;
               "12",contw,alfabw,ccostow,liqmultiw,clasew,dtos(wfecha1),;
               dtos(wfecha2),xano1
         ENDIF


         ********************************************
         *     LIQUIDACION DE MINIMO GARANTIZADO    *
         ********************************************
         IF flagn = 1 AND empresas.min_garan = "S"  AND ;
            STR(DAY(wfecha2),2,0) $ "28,29,30,31"   AND ;
            min_garw >= wsalmin

            anow2 = year(wfecha2)
            wsalref = min_garw

*           SET STEP ON
            IF ABRIR0("nmacum",1) AND SEEK(nitw+nitemplew)
               SET RELATION TO codcon INTO concepto

               SUM IIF(ALLTRIM(concepto.codcon02)$"BASICO,OTROSCOMIS",valor,0), ;
                   IIF(nmacum.codcon=m.coniss,unid,0) ;
                   TO w_basico1 , w_dias1 ;
                   WHILE empresa+codemp = nitw+nitemplew ;
                   FOR   VAL(ano) = anow2 AND mes=mesw
            ELSE
               STORE 0 TO w_basico1, w_dias1
            ENDIF

            IF ABRIR("dtem13",1) AND SEEK(nitw+alfabw+nitemplew)
               SET RELATION TO liqcon INTO concepto

               SUM IIF(ALLTRIM(concepto.codcon02)$"BASICO,OTROSCOMIS",liqvalor,0), ;
                   IIF(dtem13.liqcon=m.coniss,liqnrohrs,0) ;
                   TO w_basico2 , w_dias2 ;
                   WHILE liqempre+liqemple = nitw+nitemplew ;
                   FOR   VAL(liqano) = anow2 AND liqmes=mesw AND liqestado="A"
            ELSE
               STORE 0 TO w_basico2, w_dias2
            ENDIF

            * ------------------------ *
            * Calcular lo que le falta *
            * para llegar al Sal. Min. *
            * ------------------------ *
            _totdiasmes = w_dias1+w_dias2+diaslab

            IF _totdiasmes = 0
               SET STEP ON
               *_totdiasmes = 30
               _totdiasmes = MIN(wfecha2,IIF(EMPTY(fecretw),wfecha2,STOD(fecretw))) ;
                             - MAX(wfecha2-DAY(wfecha2)+1,fecingw)+1

               kfec = wfecha2
               DO WHILE kfec >= wfecha1
                  IF MONTH(kfec)=2 AND (DAY(kfec)>=28) AND DAY(kfec+1)=1
                     _totdiasmes = _totdiasmes + feb30w
                     EXIT
                  ENDIF
                  kfec = kfec - 1
               ENDDO


            ENDIF
            IF (w_basico1+w_basico2)/(_totdiasmes)<wsalref/_totdiasmes
               valorw = ROUND(wsalref*_totdiasmes/30,0)-(w_basico1+w_basico2)
               valorw = MAX(valorw,0)
               IF valorw # 0
                  totdev = totdev + valorw
                  worigen='AU'

                  DO add_dtem WITH nitw,nitemplew,m.congarant,;
                     hracobw,w_basico1+w_basico2,0,valorw,tippagw,mcuadre,;
                     mesw,contw,alfabw,ccostow,liqmultiw,clasew,;
                     dtos(wfecha1),dtos(wfecha2),xano
               ENDIF
            ENDIF

         ENDIF

         *------------------------------------------*
         *     S E G U R I D A D    S O C I A L     *
         *------------------------------------------*
*     if nitemplew="71261293"
*        set step on
*     endif

         wconsubs = TP7("CNC","ConcFdoSubsiste","01")
         IF EMPTY(wconsubs)
            wconsubs = m.confsp
         ENDIF

         IF _segsoc_ = 1 AND flagn+flagi+flagt+flagv > 0 AND ;
            clacontw # 'C' AND clacontw # 'S'   && Civiles Y Aprendices Sena
            DO LiqNomSS WITH nitw,nitemplew,contw
         ENDIF

         *******************************************
         *         RETENCION EN LA FUENTE          *
         *******************************************
         IF _retfte_ =1 AND flagn+flagi+flagt+flagv > 0 ;
            AND manret = "N"
            DO LiqNomRf WITH nitw,nitemplew,contw
         ENDIF

         *******************************************
         *      RETENCION de ICA x CIUDADES        *
         *******************************************
         * Liquidacion de Ret/ICA por Ciudades
         IF flagn = 1 AND clacontw = "C"
            DO LiqNomIc WITH nitw,nitemplew,contw,devengow,codagew
         ENDIF

         *******************************************
         *  LIQ DE PS para Contratos Adicionales   *
         *******************************************
         IF flagn+flagt > 0 AND tipcontw = 'A' AND clacontw # 'C'
            DO liqNomCA WITH nitw,nitemplew,contw
         ENDIF

         * **************************************** *
         * LIQ. DE DESCUENTOS DE PRESTAMOS CON INT. *
         * **************************************** *
         IF _pagar_ = 1 AND ;
            flagn+flagt+flagi+flagv > 0 AND FILE('LIQNOMPI.FXP')
            DO LiqNomPI WITH nitw,nitemplew,contw
         ENDIF

         * **************************************** *
         * LIQ. DE CONCEPTOS EX-NOMINA: PROV-ITMFAC *
         * **************************************** *
         IF FILE("liqnomot.fxp") AND FILE("nmactiv3.dbf")
            DO liqnomot WITH nitw,nitemplew,contw,wconsec
         ENDIF

         SELECT empleado        && A
         IF _reg_empl > 0
            GO _reg_empl
         ELSE
            SET ORDER TO 1
            =SEEK(nitw+nitemplew+contw)
         ENDIF

         IF flagn+flagt+flagi >0 OR devengow > 0
            IF mtipo='D' && AND rblokado(7)

               _corte = DTOS(wfecha2)
               STORE nitemplew  TO mced, wced
               DO GRABPROC WITH "LIQNOM2:D:"+_corte,'A'
               SELECT empleado
               IF empleado.nitemple+empleado.ncontrato<>nitemplew+contw
                  SET ORDER TO 1
                  SEEK nitw+nitemplew+contw
               ENDIF
               IF sn # 'V'

                  =_mens("Verificacion 03 ....")

                  REPL empleado.estadoliq WITH "L"
                  REPL ULT_TIME WITH DATE()
                  IF fec_up2 < _corte AND (_conbasico OR tipcontw = 'D')
                     REPLACE empleado.fec_up1 WITH fec_up2
                     REPLACE empleado.fec_up2 WITH _corte
                  ENDIF

                  * Cerrar contratos ADICIONALES
                  IF empleado.tipcont = 'A'
                     REPLACE fecret WITH iif(!EMPTY(fhasta),fhasta,fecing)
                     REPLACE estado WITH 'P'
                     REPLACE estadoliq WITH 'P'
                  ENDIF

                  * Cerrar Contratos de Aprendices
                  IF empleado.clacont $ 'S,L,E' AND BETWEEN(STOD(fhasta),wfecha1,wfecha2)
                     REPLACE fecret WITH fhasta
                     REPLACE estado WITH 'P'
                     REPLACE estadoliq WITH 'P'
                  ENDIF
WAIT CLEAR
                  * --------------------------------------------------------------------------
                  * Renovar contratos a Termino fijo de acuerdo al indicador
                  * Se lleva control sobre FLEX.EMPLEADO.DIAS_TERFJ y FLEX.EMPLEADO.CAN_RENOVA
                  * --------------------------------------------------------------------------
                  IF empleado.tipcont = 'F' AND BETWEEN(STOD(fhasta),wfecha1,wfecha2)
                     _dias = VAL(TRAE_DATO('FLEX7SRH',1,'EMPLEADO'+'DIAS_TERFJ'+nitemple+[-]+ncontrato,'ALLTRIM(LEFT(dato,3))'))
                     _cant = VAL(TRAE_DATO('FLEX7SRH',1,'EMPLEADO'+'CAN_RENOVA'+nitemple+[-]+ncontrato,'ALLTRIM(LEFT(dato,3))'))


                     IF mensaje(TRIM(Nombre)+CHR(13)+'Per:'+fecing+[-]+fhasta+CHR(13)+'    Renueva ?')

                        _llave = nitemple+[-]+ncontrato
                        _nfech = IIF(_cant=3 OR _dias>=360,STR(VAL(LEFT(fhasta,4))+1,4)+SUBST(fhasta,5,4),DTOS(STOD(fhasta)+_dias))

                        IF ABRIR('flex7srh',1)
                           =_mens("Verificacion 04 ....")
                           IF !SEEK('EMPLEADO'+'CAN_RENOVA'+_llave)
                              APPEND BLANK
                              REPLACE tabla WITH 'EMPLEADO', campo WITH 'CAN_RENOVA', ;
                                      llave WITH _llave, dato WITH STR(_cant+1,2)+' '+empleado.fhasta+' '+_nfecha
                           ELSE
                              REPLACE dato WITH STR(_cant+1,2)+' '+empleado.fhasta+' '+_nfecha
                           ENDIF

                     =_mens("Verificacion 05 ....")

                           SELECT empleado
                           REPLACE fhasta WITH _nfecha
                           WAIT CLEAR
                        ENDIF
                     ENDIF
                  ENDIF
              UNLOCK
              ENDIF
              * Marcar registros de Primas por Listado
              IF sn1 = 'L' AND ABRIR('nmprimas',1)
                 IF SEEK(nitemplew+contw)

                    =_mens("Verificacion 06 ....")

                    DO WHILE codigo+numcnt=nitemplew+contw
                       IF estado = 'a' AND consec=wconsec
                          REPLACE estado WITH 'P'
                       ENDIF
                       SKIP
                    ENDDO
                    WAIT CLEAR
                 ENDIF
              ENDIF
            ELSE

              SELECT dtem13
              IF mtipo ="T"
                 IF SEEK(nitw)
                      =_mens("Verificacion 07 ....")

                    DO WHILE liqempre=nitw
                       IF liqemple   = q_empl.nitemple  AND ;
                          liqcontrat = q_empl.ncontrato AND ;
                          consec # wconsec AND liqestado = "A"
                          REPLACE liqestado WITH "G"
                       ENDIF
                       SKIP
                    ENDDO
                    WAIT CLEAR
                 ENDIF
              ENDIF

            ENDIF
         ENDIF

      ENDIF
   ENDIF

   SELECT q_empl        &&empleado   && A
   SKIP

ENDDO

SELECT dtem13
SET ORDER TO 7

IF SEEK(wconsec)
   liq = 1
   SET RELATION TO liqcon INTO concepto
   SUM liqvalor WHILE consec=wconsec ;
       FOR liqestado='A' ;
       AND concepto.pod $ [P,D] ;
       TO w7_neto
   IF mtipo = [T]
      IF ABRIR('flex7srh',1)

                      =_mens("Verificacion 08 ....")

         IF !SEEK([LIQNOM  ]+[TENTATIVA_]+nitw)
            APPEND BLANK
            REPLACE tabla WITH [LIQNOM  ], campo WITH [TENTATIVA_],;
                    llave WITH nitw, dato WITH wpernom+STR(w7_neto,15,2)
         ELSE
            REPLACE dato WITH wpernom+STR(w7_neto,15,2)+[ ]+wconsec
         ENDIF
         WAIT CLEAR
      ENDIF
      =_CLOSE('flex7srh')
   ELSE
      _dato_tnt = TRAE_DATO('FLEX7SRH',1,[LIQNOM  ]+[TENTATIVA_]+nitw,[ALLTRIM(dato)])
      IF wpernom = LEFT(_dato_tnt,6)
         _neto_tnt = VAL(SUBST(_dato_tnt,7,15))
         _consec1  = SUBST(_dato_tnt,23,8)
         IF _neto_tnt # W7_Neto AND FILE('liqnomrv.fxp') AND ;
            MENSAJE('Liquidaciones NO concuerdan, Revisar?')
            DO liqnomrv WITH _consec1,wconsec
         ENDIF
      ENDIF
   ENDIF
ELSE
   liq = 0
ENDIF

SHOW GET w7_neto

*set step on
* ----------------------------------- *
* Revisar registros  de Vacaciones ya *
* liquidados y  pendientes por  pagar *
* para incluirlos en esta liquidacion.*
* ----------------------------------- *
IF _GET_STEP AND GET_STEP(5," Rev Vacaciones ")
   set step on
ENDIF

=_CLOSE("empleado","empresas","noved","tabgen00","tabgen01","dtem13","solivaca",'solianti')
=_CLOSE("ncontrol","usuarios","novedpnd","concepto","dtem13i","tiempos")
=_CLOSE("descuent",'procesos',"pagare01","pagare02","nmactiv1","nmactiv2")


IF liq = 0
   WAIT CLEAR
   WAIT WINDOW "<<< CUIDADO ..... NO SE HA LIQUIDADO NINGUN EMPLEADO >>>" timeout 1200

ELSE

   IF sn1#'L' AND _repo2_ = 1
      DO rev_incons
      IF clasew#'O'
         DO rev_fact   && Revisar que conceptos no estan matriculados en SUBCON
      ENDIF
   ENDIF

   IF _audit_ = 1 AND FILE("liqnomau.fxp")
      DO LiqNomAu
   ENDIF

ENDIF

IF ABRIR("noved",1) AND EMPTY(wgru) AND SEEK(nitw)
   =_mens("Verificacion 09 ....")

   DO WHILE novempre=nitw
      IF novestado = "a"
         REPLACE novestado WITH "A"
      ENDIF
      SKIP
   ENDDO

   WAIT CLEAR
ELSE

   DO rec_novpre

ENDIF
=_CLOSE("noved")

*DEACTIVATE WINDOW w_liqnom
DEACTIVATE WINDOW w_liqnom2
DEACTIVATE WINDOW consult4
*RELEASE WINDOW w_liqnom,w_liqnom2
RELEASE WINDOW w_liqnom

RELEASE wnit, _ccosto
UNLOCK ALL
WAIT CLEAR
DO CLOSE_DATA
SET CONF OFF
= estableconf()
UNLOCK ALL

* ------------------------- *
* REVISAR EL LISTADO
* ------------------------- *
IF liq > 0 AND _repo1_ = 1

  * (_repo1_ = 1 OR mensaje('Desea Visualizar la Liquidacion ?'+CHR(13)+' Neto: '+ALLTRIM(TRAN(w7_neto,"999,999,999,999"))) )

   IF _repo1_ = 1
      CLEAR TYPEAHEAD
      KEYBOARD CHR(13)+CHR(13)+"{PgDn}"+CHR(13)
   ENDIF

   DO LiqNomLS WITH IIF(mtipo='D',2,1)
   IF FILE('datbasrt.dbf') AND ABRIR('datbasrt',2) AND SEEK(wconsec)
      IF FILE("liqnomrt.frx")
         REPORT FORM liqnomrt WHILE consec = wconsec NOCONSOLE TO PRINT
      ELSE
         =_MENS("Recuerde agregar Reporte: LiqNomRt.Frx")
      ENDIF
   ENDIF
ENDIF

* -------------------------- *
* Automaticos de acumulacion *
* -------------------------- *
IF liq > 0 AND wautomatic

   =_mens("Realizando PROCESO DE ACUMULACION")


   DO WHILE .T.
      =_CLOSE('dtem13','rangdcto')
      SELECT DIST liqtippag, tipodcto ;
        FROM dtem13, rangdcto ;
       WHERE liqtippag = tipopago ;
         AND liqestado = "A" ;
        INTO CURSOR q_bancos

      =_CLOSE('dtem13','rangdcto')

      SELECT q_bancos
      IF RECC()>0
         GO TOP
         ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN
         ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
         browse normal nomo
         DO cbte_pag WITH "N",q_bancos.tipodcto,nitw
         ON KEY LABEL ENTER
         ON KEY LABEL F8

      ELSE
         EXIT
      ENDIF
   ENDDO

   DEACTIVATE WINDOW pantalla
ENDIF

UNLOCK ALL
DO CLOSE_DATA

RETURN
******

FUNCTION _enable
IF (!EMPTY(wgru2) OR !EMPTY(wraz) ) AND ;
    !EMPTY(wfecha1) AND !EMPTY(wfecha2) AND ;
    !EMPTY(period) AND !EMPTY(wdi_)

    SHOW GET wb_sal,1 ENABLE
    ON KEY LABEL PGDN DO obj_sal2
ELSE
    SHOW GET wb_sal,1 DISABLE
    ON KEY LABEL PGDN
ENDIF

SHOW GETS WINDOW w_liqnom

RETURN .T.
******

** valida la captura del nit de la empresa
*/ --------- /*
FUNCTION ES_NIT
*/ --------- /*

IF _get_step AND GET_STEP(5,"Validac Negocio")
   SET STEP ON
ENDIF

WAIT WINDOW "Consultando .." NOWAIT
*wnit= nitw
kraz = TRAE_RAZ(nitw,.T.)

WAIT CLEAR

IF kraz # "." AND SEEK(nitw,'empresas')
   wraz = kraz
*  nitw = wnit
   SHOW GET wraz
   SHOW GET nitw
   SET FUNCTION 10 TO nitw

   IF !EMPTY(empresas.prmsliqn)
      _Pr_    = empresas.prmsliqn
*     mesw    = SUBST(_pr_,1,2)
      wfecha1 = STOD(SUBST(_pr_,03,8))
      wfecha2 = STOD(SUBST(_pr_,11,8))
      period  = SUBST(_pr_,19,1)
      wdom    = VAL(SUBST(_pr_,20,1))
      wfes    = VAL(SUBST(_pr_,21,1))
*     fecort  = STOD(SUBST(_pr_,22,8))
      fecort  = IIF(MONTH(wfecha2)>10,CTOD(STR(YEAR(wfecha2),4)+'.12.30'),CTOD(STR(YEAR(wfecha2),4)+'.06.30'))
      wdi_    = f_difdias(wfecha2,wfecha1,nitw)

*     SHOW GET mesw
      SHOW GET wfecha1
      SHOW GET wfecha2
      SHOW GET period
      SHOW GET wdom
      SHOW GET wfes
      SHOW GET fecort
      SHOW GET wdi_
   ENDIF

   SET FUNCTION 10 TO nitw

   IF empresas.hrsdomi <=0
      STORE 0 TO wdom
      SHOW GET wdom DISABLE
   ELSE
      SHOW GET wdom ENABLE
   ENDIF

   IF empresas.hrsfest <=0
      STORE 0 TO wfes
      SHOW GET wfes DISABLE
   ELSE
      SHOW GET wfes ENABLE
   ENDIF

   IF !mliqprima
      STORE "N" TO sn,sn1
      SHOW GET sn     DISABLE
      SHOW GET sn1    DISABLE
      SHOW GET fecort DISABLE
   ENDIF
   SHOW GETS WINDOW w_liqnom
   =w_pernom()
   RETURN _enable()
ENDIF
RETURN .F.
******


** cierra las posibles tablas abiertas
*/ -------------- /*
PROCEDURE CLOSE_DATA
*/ -------------- /*
=_CLOSE("dtem13","empresas","empleado","cencosto","nmacum","concepto")
=_CLOSE("usuarios","ncontrol","tabgen00","tabgen02","opcusupe","tabgen10")
=_CLOSE("tiempos","noved","descuent","novedpnd","cntabanc","selpr001")
=_CLOSE("datbas01","datbasrt","q_incap","q_nmac","incap_00","nmgrupo1","nmgrupo2")
=_CLOSE("dtem13w","solipres")
RETURN
******


** valida la fecha final de liquidacion
*/ ----------- /*
function v_fechas
*/ ----------- /*
if wfecha2 >= wfecha1

  if _leninia = 6
    ** preparo validaciones con ano de dos digitos
    _ano1_ = left(winicioano,2)
    _ano2_ = str(mod(year(wfecha2),100),2,0)
  else
    ** preparo validaciones con ano de cuatro digitos
    _ano1_ = left(winicioano,4)
    _ano2_ = str(year(wfecha2),4,0)
  endif

  if _ano2_ >= _ano1_
    wdi_ = f_difdias(wfecha2,wfecha1,nitw)
    SHOW GET wdi_

    IF EMPTY(nitw) AND USED('q_negrup')
       SELE q_negrup
       GO TOP
       _hrsfest = TRAE_DATO('empresas',1,q_negrup.negoci,'hrsfest')
    ELSE
       _hrsfest = TRAE_DATO('empresas',1,nitw,'hrsfest')
    ENDIF

    IF _hrsfest > 0 AND ;
       ABRIR0('tabgen10',1) AND SEEK('FE')

       COUNT TO wfes FOR BETWEEN(datfec,wfecha1,wfecha2) ;
             WHILE tipfec="FE"
    ELSE
       wfes = 0
    ENDIF
    SHOW GET wfes

    return .t.
  else
    return .f.
  endif

else
  return .f.
endif
return
******


** retorna el valor del parametro en fecha
*/ ----------- /*
function turndate
*/ ----------- /*
parameters _dchar_
if len(_dchar_) = 6
  if val(substr(_dchar_,1,2)) >= 80
    _adicion_ = "19"
  else
    _adicion_ = "20"
  endif
  return ctod(_adicion_ + substr(_dchar_,1,2) + "/" + substr(_dchar_,3,2) + "/" + substr(_dchar_,5,2) )
else
  return ctod( substr(_dchar_,1,4) + "/" + substr(_dchar_,5,2) + "/" + substr(_dchar_,7,2) )
endif



** retorna el valor del ano dependiendo de la longitud del campo y del valor
** de la variable
*/ ---------- /*
function retyear
*/ ---------- /*
parameters _fiel_ , _var_

if len(_fiel_) = 2
  ret_ = str(mod(_var_,100),2,0)
else
  ret_ = str(_var_,4,0)
endif
return ret_


function estableconf
set century &_century_
set date to &_date_
RETURN .T.
******

function v_descuento
if _descuen_ = 0
  wdes = "N"
else
  wdes = "S"
endif
RETURN .T.
******

FUNCTION val_proy

IF sn1 = "S"
   fecort = IIF(MONTH(DATE()-21)>10,CTOD(STR(YEAR(DATE()),4)+'.12.30'),CTOD(STR(YEAR(DATE()),4)+'.06.30'))
   SHOW GET fecort  ENABLE
ELSE
   SHOW GET fecort  DISABLE
ENDIF
RETURN .T.
******

FUNCTION val_ced
IF EMPTY(wced)
   wnom = "Todos los Trab Activos Nomina"
   SHOW GET wnom
   RETURN .T.
ELSE

   kpos = AT("*",wced)
   kpos1= AT("/",wced)
   kres = ALLTRIM(SUBS(wced,kpos+1,7))
   kcod = ALLTRIM(LEFT(wced,kpos-1))
   knom = ALLTRIM(RIGHT(wced,kpos+1))

   IF kpos > 0  AND ABRIR('noved',1)

         SELECT DISTINCT novemple,novcont ;
           FROM noved ;
          WHERE novestado $ "aA" ;
            AND novempre = nitw ;
            AND (EMPTY(kcod) OR novemple=kcod);
           INTO CURSOR q1_nov

         DO DEF_WIND WITH "1","Trabajadores Con novedades Activas para Nomina"
         ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
         ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN
         BROWSE NOMO WINDOW consulta ;
                FREEZE novemple ;
                FIELDS novemple, Cnt=Novcont, ;
                       nombre=TRAE_NOM(novemple)
         ON KEY LABEL ENTER
         ON KEY LABEL F8

         IF LASTKEY() #27
            wced = novemple
            wnom = TRAE_NOM(novemple)
            SHOW GET wced
            SHOW GET wnom
            SET FUNCTION 9 TO wced
         ENDIF

   ENDIF

   _ok = .F.

   IF USED("empleado")
      SELECT empleado
      SET ORDER TO TAG indemp
      IF SEEK(nitw+wced)
         DO WHILE !EOF() AND nitempre+nitemple=nitw+wced
            IF estado $ [a,A,L]
               wcnt = ncontrato
               wnom = nombre
               SHOW GET wnom
               SHOW GET wcnt
               SET FUNCTION 9 TO wced
               EXIT
            ENDIF
            SKIP
         ENDDO
      ENDIF
      _ok = (nitempre+nitemple=nitw+wced AND estado $[a,A,L])
   ELSE
      SELECT 0
      USE empleado ORDER TAG indemp
      IF SEEK(nitw+wced)
         DO WHILE !EOF() AND nitempre+nitemple=nitw+wced
            IF estado $ [a,A,L]
               wcnt = ncontrato
               wnom = nombre
               SHOW GET wnom
               SHOW GET wcnt
               SET FUNCTION 9 TO wced
               EXIT
            ENDIF
            SKIP
         ENDDO
      ENDIF
      _ok = (nitempre+nitemple=nitw+wced AND estado $[a,A,L])
      USE IN empleado
      RETURN _ok
   ENDIF
ENDIF
RETURN .F.
******

FUNCTION val_cnt
IF "*" $ wcnt
   IF ABRIR0('empleado',6)
      DO DEF_WIND WITH "1", 'Contratos Activos:'+wnom
      ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
      ON KEY LABEL F8 KEYBOARD  "{CTRL+W}" PLAIN
      BROWSE KEY wced WINDOW consulta FREE ncontrato ;
       FIELD ncontrato: H="Cnt", fecing, fecret, ccosto, hrapag, ;
             Ret_prog = TRAE_FEC_SP(nitemple,ncontrato) ;
         FOR estado $ "a,A,L" AND nitempre=nitw
      ON KEY LABEL ENTER
      ON KEY LABEL F8
      IF LASTKEY() # 27
         wcnt =  ncontrato
         SHOW GET wcnt
      ENDIF
      USE IN empleado
   ENDIF
ENDIF
_ok = .F.
IF ABRIR('empleado',6)
   IF SEEK(wced+wcnt) AND ;
      estado $ [a,A,L] AND ;
      nitempre = nitw
      _ok = .T.
   ENDIF
ENDIF
RETURN _ok
******

PROCEDURE repl_est
=SEEK(nitw)
=_mens("Verificacion1 10 ....")

DO WHILE liqempre=nitw
   IF liqestado='A' AND (DG = _wuser OR borrarant)
      REPLACE liqestado WITH 'G'
   ENDIF
   SKIP
ENDDO
WAIT CLEAR
RETURN
******

PROCEDURE repl_est1
PARAMETERS _cod,_cnt
SELECT dtem13
SET ORDER TO 6
IF SEEK(_cod+_cnt)
   =_mens("Verificacion 11 ....")

   DO WHILE liqemple = _cod AND liqcontrat = _cnt
      IF liqestado='A'
         REPLACE liqestado WITH 'G'
      ENDIF
      SKIP
   ENDDO
   WAIT CLEAR
ENDIF
RETURN
******

PROCEDURE rev_incons

IF _get_step AND GET_STEP(5,'Rev  Inconsistencias')
   SET STEP ON
ENDIF

_men = "Revisando Inconsistencias "
=_mens(_men,.t.,2)
=_CLOSE('_novpnd')

STORE 0 TO mpend, mpend1, _errores
CREATE CURSOR _incons (ced c(8), nom C(30), hrs N(9,2), ;
               iss N(9), tra n(9), dev N(11,2), ;
               net N(11,2), tpg C(3), ini C(8), ret C(8), tipo C(18))

IF EMPTY(wgru) AND ABRIR("NOVED",1) AND SEEK(nitw) AND ;
   ABRIR('empleado',6)

   SELECT noved
   SET RELATION TO novemple+novcont INTO empleado
   _ki1 = FILETEMP(1)
   COPY TO (_Ki1) WHILE novempre=nitw FOR novestado='A' AND ;
           indnom = "S" AND (EMPTY(wsuc) OR empleado.codage=wsuc)
   mpend1 = _TALLY
   USE (_Ki1) ALIAS _novpnd EXCL
ELSE
   mpend1 = 0
ENDIF

* Verificar que cada trabajador no tenga mas "pagos"
* de los que debe tener en este periodo

_dtem = IIF(mtipo="D",'dtem13','dtem13w')

*IF _wuser = "SUP"
*   SET STEP ON
*ENDIF

IF ABRIR(_dtem,3,"dtem13") AND SEEK(nitw)


   * Busbamos el tope de horas maximo permitidas para liquidar la nomina
   * por periodicidad de pago
   _tope = TD7("tabgen11",1,"P1"+period,"Nume01")
   DO WHILE !EOF() AND liqempre = nitw
      IF consec # wconsec
         SKIP
         LOOP
      ENDIF
      _ced = liqemple
      _tpg = ALLTRIM(liqtippag)
      _ing = STOD(TRAE_DATO("empleado",6,liqemple+liqcontrat,"fecing"))
      _ret = TRAE_FEC_SP(liqemple,liqcontrat)
      _ret = IIF(EMPTY(_ret),wfecha2,STOD(_ret))

      xdi_ = MIN(_ret,wfecha2)-MAX(_ing,wfecha1)+1
      xdi2 = MIN(_ret,wfecha2)-MAX(_ing,wfecha1)+1

      IF DAY(wfecha2+1)=1 AND MONTH(wfecha2+1)=3 AND ;
         horasperw=120 AND (xdi_=13 OR xdi_=14)
         xdi_ =15
      ENDIF

      STORE 0 TO _iss,_tra,_hrs,_net,_dev,_diasacu,_diastra

      _area = SELECT()
      IF ABRIR0('nmacum',6) AND SEEK(xano+mesw+m.coniss+_ced)
         SUM unid TO _diasacu ;
             WHILE ano+mes+codcon+codemp = xano+mesw+m.coniss+_ced
         IF SEEK(xano+mesw+m.conauxtra+_ced)
            SUM unid TO _diastra ;
                WHILE ano+mes+codcon+codemp = xano+mesw+m.conauxtra+_ced
         ENDIF
      ENDIF
      SELECT (_area)

      _errmin = []
      DO WHILE liqemple=_ced

         IF liqestado = "A" AND (mtipo='D' OR consec=wconsec)

            IF liqcon=m.coniss
               _iss = _iss + liqnrohrs
            ENDIF
            IF liqcon=m.conauxtra
               _tra = _tra + liqnrohrs
            ENDIF

            xtim = td7("concepto",1,liqcon,'tiempo+codcon02')
            xgru = SUBST(xtim,2,8)
            xtim = LEFT(xtim,1)
            IF xtim $"H,D" AND xgru $"BASICO  ,EXTRAS  ,VACLEG  "

               _basemin = ROUND(wsalmin / IIF(xtim="H",240,30),3)
               IF liqhrapag < _basemin AND  liqhrapag > 0
                  _errmin = "Liq TIEMPO inf SML"
               ENDIF
            ENDIF
            IF liqcon=m.conh100 OR liqcon=m.conh135 OR ;
               liqcon=m.conh200 OR liqcon=m.conh235 OR ;
               liqcon=m.con100d OR liqcon=m.con100f OR ;
               liqcon=m.con100c
               _hrs = _hrs + liqnrohrs

            ENDIF

            _net = _net + liqvalor
            IF liqvalor > 0
               _dev = _dev + liqvalor
            ENDIF

            IF AT(liqtippag,_tpg)=0
               _tpg = ALLTRIM(_tpg) + liqtippag
            ENDIF
         ELSE
         ENDIF

         SKIP
      ENDDO

      IF _iss > xdi_ OR _tra > xdi_ OR _hrs > hrsdiaw*xdi_ OR ;
         !BETWEEN(_dev,0,_max) OR LEN(_tpg) # 1 OR _net <= 0 OR;
         !EMPTY(_errmin)

         mced = _ced
         mnit = nitw

         =_mens("Verificacion 12 ....")

         SELECT _incons
         APPEND BLANK
         REPLACE ced WITH _ced , nom WITH trae_nom(_ced)
         IF _tra > xdi_
            REPLACE tra WITH _tra
         ENDIF
         IF _iss > xdi_
            REPLACE iss WITH _iss
         ENDIF
         IF _hrs > hrsdiaw*xdi_
            REPLACE hrs WITH _hrs
            IF _tope > 0 AND _hrs > _tope
               REPLACE tipo WITH "ERR:"+ALLTRIM(STR(_tope,15,2))
            ENDIF
         ENDIF

         IF !EMPTY(_errmin)
            REPLACE tipo WITH ALLTRIM(tipo)+_errmin
         ENDIF

         IF !BETWEEN(_dev,0,_max)
            REPLACE dev WITH _dev
         ENDIF

         IF _net <= 0
            REPLACE net  WITH _net
         ENDIF

         IF LEN(_tpg) # 1
            REPLACE tpg WITH _tpg
         ENDIF

         IF BETWEEN(_ing,wfecha1+1,wfecha2)
            REPLACE ini WITH DTOS(_ing)
         ENDIF

         IF BETWEEN(_ret,wfecha1,wfecha2-1)
            REPLACE ret WITH DTOS(_ret)
         ENDIF

         WAIT CLEAR
         DO grabproc WITH "LiqNom:Inconsist/"+nitw,"A", ;
                          "LiqNom:Inconsist/"+_ced,"B"
         SELECT dtem13
      ENDIF

   ENDDO

ENDIF

IF mpend1 > 0
   MLIN = 'Se encontraron sin liquidar'+_C13+;
          '  Novedades: '+STR(mpend1,4)+_c13+;
          '  DESEA CONSULTARLAS  ? '
   DO grabproc WITH "Noved Sin Liq"+nitw,"A",nitw+STR(mpend,4)+STR(mpend1,4),"B"
   IF mensaje(mlin)
      SELECT _novpnd
      GO TOP
      DO DEF_WIND WITH "1",'Novedades NO LIQUIDADAS'
      ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN
      ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
      BROW NOMO WINDOW consulta FIELD ;
           age=TRAE_DATO('empleado',6,novemple+novcont,'codage'), ;
           novcon: H='Cnc':w=w_cnc(novcon), ;
           novemple :H='Codigo', novcont :H="Cnt", novunid, novvalor, ;
           dg,fech_grab,hora_grab:h="Hora", ;
           nombre = TRAE_NOM(novemple), ;
           Nom=indnom, indprs:H="P.S", ;
           per=TRAE_DATO("empleado",6,novemple+novcont,'formpago'), ;
           liq=TRAE_DATO("empleado",6,novemple+novcont,'estadoliq'), ;
           Nom_cub=TRAE_DATO("empleado",6,novemple+novcont,'fec_up2')
      ON KEY LABEL F8
      ON KEY LABEL ENTER

   ENDIF

   =_CLOSE('_novpnd')
ENDIF

IF RECC("_incons") > 0
   WAIT WINDOW "OJO INCONSISTENCIAS"

   SELECT _incons
   COUNT TO _errores FOR !EMPTY(tipo)

   ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN
   ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN

   BROWSE NOMO NORMAL NODE NOAP TITLE 'Inconsistencias de Proceso'
   ON KEY LABEL F8
   ON KEY LABEL ENTER

   IF LASTKEY()#27 AND ;
      MENSAJE('Desea imprimir Directo en la Impresora?')
      warc = FILETEMP(3)
      SET CONSOLE OFF
      LIST OFF TO FILE (warc)
      TYPE (warc) TO PRINT PROMPT
      SET CONSOLE ON
      DELETE FILE (warc)
   ENDIF

   IF _errores > 100
      SELECT dtem13
      =_MENS("Bloqueando NOMINA ....")
      REPLACE liqestado WITH "G" FOR consec = wconsec AND liqestado="A"
      =MESSAGEBOX("NOMINA BLOQUEADA"+CHR(13)+"Muchas Inconsistencias",16,"ALERTA",12000)
      DO grabproc WITH "LiqNom:"+mtipo+nitw+" "+wconsec+" BLOQUEA","G"
   ENDIF
ENDIF

RETURN
******


PROCEDURE _rev_incons

IF _get_step AND GET_STEP(5,'Rev  Inconsistencias')
   SET STEP ON
ENDIF

_men = "Revisando Inconsistencias "
=_mens(_men)
=_CLOSE('_novpnd')

STORE 0 TO mpend, mpend1
CREATE CURSOR _incons (ced c(8), nom C(30), hrs N(9,2), ;
               iss N(9), tra n(9), dev N(11,2), ;
               net N(11,2), tpg C(3), ini C(8), ret C(8), CLA C(1), LIM C(8))

IF EMPTY(wgru) AND ABRIR("NOVED",1) AND SEEK(nitw) AND ;
   ABRIR('empleado',6)

   SELECT noved
   SET RELATION TO novemple+novcont INTO empleado
   _ki1 = FILETEMP(1)
   COPY TO (_Ki1) WHILE novempre=nitw FOR novestado='A' AND ;
           indnom = "S" AND (EMPTY(wsuc) OR empleado.codage=wsuc) AND ;
           (EMPTY(wced) OR novemple=wced)
   mpend1 = _TALLY
   USE (_Ki1) ALIAS _novpnd EXCL
ELSE
   mpend1 = 0
ENDIF

* Verificar que cada trabajador no tenga mas "pagos"
* de los que debe tener en este periodo

_dtem = IIF(mtipo="D",'dtem13','dtem13w')

*IF _wuser = "SUP"
*   SET STEP ON
*ENDIF

IF ABRIR(_dtem,3,"dtem13") AND SEEK(nitw)

   DO WHILE !EOF() AND liqempre = nitw
      IF consec # wconsec
         SKIP
         LOOP
      ENDIF
      _ced = liqemple
      _tpg = ALLTRIM(liqtippag)
      _ing = STOD(TRAE_DATO("empleado",6,liqemple+liqcontrat,"fecing"))
      _lim = TRAE_DATO("empleado",6,liqemple+liqcontrat,"FHASTA")
      _ret = TRAE_FEC_SP(liqemple,liqcontrat)
      _ret = IIF(EMPTY(_ret),wfecha2,STOD(_ret))

      xdi_ = MIN(_ret,wfecha2)-MAX(_ing,wfecha1)+1
      xdi2 = MIN(_ret,wfecha2)-MAX(_ing,wfecha1)+1

      IF DAY(wfecha2+1)=1 AND MONTH(wfecha2+1)=3 AND ;
         horasperw=120 AND (xdi_=13 OR xdi_=14)
         xdi_ =15
      ENDIF

      IF !EMPTY(_lim)
         _tcn = TRAE_DATO("empleado",6,liqemple+liqcontrat,"clacont")
         * Buscamos dias de gracia x clase contrato
         _li2 = TRAE_DATO("tabgen11",1,[CC]+_tcn,"nume01")
         * Quitamos dias de gracia para ver si hay q notificar
         * Sobre la terminacion del contrato
         IF STOD(_lim) - _Li2 > wfecha2
            * Limpiamos flimite para no incluir en inconsistencias
            _lim = []
         ENDIF

      ELSE
         _tcn = []
      ENDIF

      STORE 0 TO _iss,_tra,_hrs,_net,_dev,_diasacu,_diastra

      _area = SELECT()
      IF ABRIR0('nmacum',6) AND SEEK(xano+mesw+m.coniss+_ced)
         SUM unid TO _diasacu ;
             WHILE ano+mes+codcon+codemp = xano+mesw+m.coniss+_ced
         IF SEEK(xano+mesw+m.conauxtra+_ced)
            SUM unid TO _diastra ;
                WHILE ano+mes+codcon+codemp = xano+mesw+m.conauxtra+_ced
         ENDIF
      ENDIF
      SELECT (_area)

      DO WHILE liqemple=_ced

         IF liqestado = "A" AND (mtipo='D' OR consec=wconsec)

            IF liqcon=m.coniss
               _iss = _iss + liqnrohrs
            ENDIF
            IF liqcon=m.conauxtra
               _tra = _tra + liqnrohrs
            ENDIF

            IF liqcon=m.conh100 OR liqcon=m.conh135 OR ;
               liqcon=m.conh200 OR liqcon=m.conh235 OR ;
               liqcon=m.con100d OR liqcon=m.con100f OR ;
               liqcon=m.con100c
               _hrs = _hrs + liqnrohrs
            ENDIF

            _net = _net + liqvalor
            IF liqvalor > 0
               _dev = _dev + liqvalor
            ENDIF

            IF AT(liqtippag,_tpg)=0
               _tpg = ALLTRIM(_tpg) + liqtippag
            ENDIF
         ELSE
         ENDIF

         SKIP
      ENDDO

      IF _iss > xdi_ OR _tra > xdi_ OR _hrs > hrsdiaw*xdi_ OR ;
         !BETWEEN(_dev,0,_max) OR LEN(_tpg) # 1 OR _net <= 0 OR !EMPTY(_lim)

         mced = _ced
         mnit = nitw

                     =_mens("Verificacion 14 ....")

         SELECT _incons
         APPEND BLANK
         REPLACE ced WITH _ced , nom WITH trae_nom(_ced)
         IF _tra > xdi_
            REPLACE tra WITH _tra
         ENDIF
         IF _iss > xdi_
            REPLACE iss WITH _iss
         ENDIF
         IF _hrs > hrsdiaw*xdi_
            REPLACE hrs WITH _hrs
         ENDIF

         IF !BETWEEN(_dev,0,_max)
            REPLACE dev WITH _dev
         ENDIF

         IF _net <= 0
            REPLACE net  WITH _net
         ENDIF

         IF LEN(_tpg) # 1
            REPLACE tpg WITH _tpg
         ENDIF

         IF BETWEEN(_ing,wfecha1+1,wfecha2)
            REPLACE ini WITH DTOS(_ing)
         ENDIF

         IF BETWEEN(_ret,wfecha1,wfecha2-1)
            REPLACE ret WITH DTOS(_ret)
         ENDIF

         IF !EMPTY(_lim)
            REPLACE lim WITH _lim, cla WITH _tcn
         ENDIF

         WAIT CLEAR
         DO grabproc WITH "LiqNom:Inconsist/"+nitw,"A", ;
                          "LiqNom:Inconsist/"+_ced,"B"
         SELECT dtem13
      ENDIF

   ENDDO

ENDIF

IF mpend1 > 0
   MLIN = 'Se encontraron sin liquidar'+_C13+;
          '  Novedades: '+STR(mpend1,4)+_c13+;
          '  DESEA CONSULTARLAS  ? '
   DO grabproc WITH "Noved Sin Liq"+nitw,"A",nitw+STR(mpend,4)+STR(mpend1,4),"B"
   IF mensaje(mlin)
      SELECT _novpnd
      GO TOP
      DO DEF_WIND WITH "1",'Novedades NO LIQUIDADAS'
      ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN
      ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
      BROW NOMO WINDOW consulta FIELD ;
           age=TRAE_DATO('empleado',6,novemple+novcont,'codage'), ;
           novcon: H='Cnc':w=w_cnc(novcon), ;
           novemple :H='Codigo', novcont :H="Cnt", novunid, novvalor, ;
           dg,fech_grab,hora_grab:h="Hora", ;
           nombre = TRAE_NOM(novemple), ;
           Nom=indnom, indprs:H="P.S", ;
           per=TRAE_DATO("empleado",6,novemple+novcont,'formpago'), ;
           liq=TRAE_DATO("empleado",6,novemple+novcont,'estadoliq'), ;
           Nom_cub=TRAE_DATO("empleado",6,novemple+novcont,'fec_up2')
      ON KEY LABEL F8
      ON KEY LABEL ENTER

   ENDIF

   =_CLOSE('_novpnd')
ENDIF

IF RECC("_incons") > 0
   WAIT WINDOW "OJO INCONSISTENCIAS" NOWAIT

   SELECT _incons
   ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN
   ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN

   BROWSE NOMO NORMAL NODE NOAP TITLE 'Inconsistencias de Proceso'
   ON KEY LABEL F8
   ON KEY LABEL ENTER

   IF LASTKEY()#27 AND ;
      MENSAJE('Desea imprimir Directo en la Impresora?')
      warc = FILETEMP(3)
      SET CONSOLE OFF
      LIST OFF TO FILE (warc)
      TYPE (warc) TO PRINT PROMPT
      SET CONSOLE ON
      DELETE FILE (warc)
   ENDIF
ENDIF

RETURN
******

FUNCTION w_cnc
PARAMETER _codcnc
=_MENS(TRAE_DATO("concepto",1,_codcnc,[ALLTRIM(descr)]))
RETURN .T.
******

FUNCTION _dias
PARAMETER _dev,_hra,_can

IF _hra*_can # 0
   _vlr = ROUND((_dev*30/(_hra*_can)),2)
ELSE
   _vlr = 0
ENDIF

RETURN MIN(_vlr,wdi_)
******

PROCEDURE rev_fact

_kf1 = FILETEMP(1)
_ks1 = FILETEMP(1)

=_CLOSE("q_dtem","q_subcon","q_notmat","q_incons","q_incnc",'subcon',"dtem13","dtem13w")

IF ((mtipo= "D" AND ABRIR("dtem13",3)) OR ABRIR("dtem13w",3)) ;
   AND SEEK(nitw)

   COPY TO (_kf1) WHILE liqempre = nitw AND liqestado = "A"

   IF _tally > 0

      SELECT 0
      USE (_kf1) EXCLUSIVE ALIAS q_dtem

      SELECT 0
      USE SUBCON ORDER 1
      IF SEEK(nitw)
         COPY TO (_ks1) WHILE empresa = nitw
      ELSE
         COPY STRUCTURE TO (_ks1 )
      ENDIF

      USE (_ks1) EXCLUSIVE ALIAS q_subcon

      SELECT DISTINC codigo ;
        FROM concepto ;
       WHERE indfact # "N" AND ;
             codigo NOT IN ( SELECT concepto ;
                               FROM q_subcon );
        INTO CURSOR q_notmat

      SELECT liqemple,liqcon,liqvalor ;
        FROM q_dtem ;
       WHERE liqcon IN (SELECT codigo ;
                          FROM q_notmat ) ;
        INTO CURSOR q_incons

      IF _tally > 0

         SELECT DISTINC  liqcon ;
           FROM q_incons ;
           INTO CURSOR q_incnc

         GO TOP
         DO WHILE !EOF()
            DO GRABPROC WITH "LiqNom:Inconsist/Conc:"+liqcon,"C"
            SKIP
         ENDDO

         SELECT q_incons
         GO TOP
         DO DEF_WIND WITH "1","Conceptos SIN MATRICULA Para facturar"
         ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
         ON KEY LABEL F8    KEYBOARD "{CTRL+W}" PLAIN
         BROWSE NOMO WINDOW consulta ;
                FIELD liqemple:H="Trabajador":w=w_tra(liqemple), ;
                      liqcon:w=w_cnc(liqcon):H="Conc", ;
                      liqvalor:H="Valor"

         ON KEY LABEL ENTER
         ON KEY LABEL F8

         =_CLOSE("q_incons","q_notmat","q_subcon","q_incnc","q_dtem")

      ENDIF

   ENDIF
ENDIF
RETURN
******

FUNCTION rblokado
PARAMETER _cuantos

RETURN rlock()
******

FUNCTION w_tra
PARAMETER _codtra
=_mens(TRAE_NOM(_codtra))
RETURN .T.
******

FUNCTION w_suc
IF FILE("LIQNOMAU.FXP")
   SHOW GET _audit_ ENABLE
ENDIF
_area_ = SELECT()
_resp_ = .F.
IF ABRIR0('tabgen00',1) AND SEEK('SC')
   IF !EOF()
      SKIP
      _resp_ =(tiptab="SC" AND codtab # '000')
   ENDIF
ENDIF
SELECT (_area_)
RETURN _resp_
******

FUNCTION v_suc
wnsc = " "
IF !EMPTY(wsuc)
   kdes = DESTAB00("SC",wsuc)
   IF !EMPTY(kdes) AND kdes # '.'
      wnsc = kdes
   ENDIF
ENDIF
SHOW GET wnsc
RETURN .T.
******

FUNCTION f_sel_nmac
PARAMETER _cod,_cnt,_ano,_mes
_whi_ = "codemp=_cod FOR ano+mes=_ano+_mes "
=_CLOSE('q_nmac')
IF !COPYDBFTMP('nmacum',2,_cod,_whi_,'q_nmac')
   CREATE CURSOR q_nmac (codemp c(8), contrato c(2), ;
                         empresa C(10), ano C(4), mes C(2), ;
                         codcon c(2), valor n(9), unid n(11,2), ;
                         cencosto c(8))
ENDIF
RETURN .T.
******

FUNCTION w_pernom
IF !EMPTY(nitw)
   _kper = TRAE_DATO('empresas',1,nitw,'formpag')
   IF (EMPTY(period) OR period#_kper)
      period = _kper
      SHOW GET period

      DO cons_per
   ELSE

      IF EMPTY(wpernom)
         DO cons_per
      ENDIF

      IF !EMPTY(wfecha1) AND !EMPTY(wfecha2)
         wdi_ = f_difdias(wfecha2,wfecha1,nitw)
         SHOW GET wdi_
      ENDIF
   ENDIF

ELSE

   IF !EMPTY(wfecha1) AND !EMPTY(wfecha2)
       wdi_ = f_difdias(wfecha2,wfecha1,nitw)
       SHOW GET wdi_
   ENDIF
ENDIF
RETURN .T.
******

PROCEDURE cons_per

      =_CLOSE('nmperiod','q_per')
      SELECT * FROM nmperiod ;
       WHERE est_per = 'A' ;
         AND pag_per = period ;
        INTO CURSOR q_per

      IF RECC('q_per')=1
         SELECT q_per
         DO cga_varper
      ELSE
         wpernom =[*]
         =v_pernom()
      ENDIF

      =_CLOSE('nmperiod','q_per')

RETURN
******

FUNCTION v_pernom
IF EMPTY(wpernom)
   RETURN .F.
ENDIF

=_CLOSE('nmperiod','q_per')
_men = ''
kpos1 = AT("*",wpernom)
kpos2 = AT("/",wpernom)
IF kpos1+kpos2 > 0
   kpos = IIF(kpos1*kpos2=0,MAX(kpos1,kpos2),MIN(kpos1,kpos2))
   kcod = LEFT(wpernom,kpos-1)
   kdes = SUBS(wpernom,kpos+1,6)
   SELECT * FROM nmperiod ;
    WHERE (EMPTY(kcod) OR cod_per = kcod) ;
      AND (EMPTY(kdes) OR ano_per = kdes) ;
      AND ( kpos1=0    OR est_per="A") ;
      AND (EMPTY(period) OR pag_per = period) ;
     INTO CURSOR q_per ;
    ORDER BY has_per DESC

   DO DEF_WIND WITH "6", "Consulta de Periodos "
   ON KEY LABEL PGDN
   ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
   ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN

   BROWSE NOMO NODE TITLE "Maestro de Periodos" FREE cod_per ;
          FIELD cod_per, ano_per: H="Ao", ;
                mes_per: H="Mes", pag_per: H="Per.P", ;
                des_per: H="Desde", has_per: H="Hasta", ;
                Est=f_est(Est_per) WINDOW consult6 FONT 'ARIAL',8
   ON KEY LABEL ENTER
   ON KEY LABEL F8

   IF LASTKEY()#27 AND est_per='A'
      DO cga_varper
   ELSE
      wpernom= ''
      _men   = IIF(est_per#'A','Periodo NO ACTIVO','')
   ENDIF

ELSE
   IF ABRIR0("nmperiod",1) AND SEEK(wpernom)
      IF est_per= "A"
         DO cga_varper
       ELSE
         _men   ='Periodo NO esta ACTIVO'
       ENDIF
   ELSE
      _men = 'Periodo NO EXISTE!'
   ENDIF
ENDIF

IF TYPE('_men')='C' AND !EMPTY(_men)
   =_mens(_men)
ENDIF

SHOW GETS WINDOW w_liqnom
RETURN .T.
******

PROCEDURE cga_varper
      wpernom= cod_per
      anow   = ano_per
      mesw   = mes_per
      period = pag_per
      wfecha1= des_per
      wfecha2= has_per
      wdi_   = f_difdias(wfecha2,wfecha1,nitw)
      _men   = ''
      SHOW GET wpernom
      SHOW GET anow
      SHOW GET mesw
      SHOW GET period
      SHOW GET wfecha1
      SHOW GET wfecha2
      SHOW GET wdi_
RETURN
******

FUNCTION f_est
PARAMETER _est
_dat = "Act"
DO CASE
   CASE _est = "A"
        _dat = "Act"
   CASE _est = "C"
        _dat = "Cer"
ENDCASE
RETURN _dat
******

PROCEDURE rec_novpre
SELECT q_empl
GO TOP
DO WHILE !EOF()

   IF ABRIR('noved',1) AND ;
      SEEK(q_empl.nitempre+q_empl.nitemple,'NOVED')

                     =_mens("Verificacion 15 ....")

      DO WHILE novempre+novemple = q_empl.nitempre+q_empl.nitemple
         IF novestado = 'a'
            REPLACE novestado WITH 'A'
         ENDIF
         SKIP
      ENDDO
      WAIT CLEAR
   ENDIF

   SELECT q_empl
   SKIP
ENDDO
RETURN
******

FUNCTION v_cco
kcco = ALLTRIM(wcco)
kpos = AT('*',kcco)

IF kpos > 0

   kini = LEFT(kcco,kpos-1)
   kres = SUBS(kcco,kpos+1,6)

   SELECT codccosto AS codigo, nomccosto AS nombre, estado ;
     FROM cencosto ;
    WHERE empccosto =  nitw ;
      AND estado $ 'AI' ;
      AND (EMPTY(kini) OR codccosto=kini) ;
      AND (EMPTY(kres) OR kres$nomccosto) ;
     INTO CURSOR q1 ;
    ORDER BY nomccosto

   ON KEY LABEL ENTER KEYBOARD "{CTRL+W}" PLAIN
   ON KEY LABEL F8 KEYBOARD "{CTRL+W}" PLAIN
   ON KEY LABEL PGDN
   DO DEF_WIND WITH '6','Maestro de Centros de Costos'
   BROWSE WINDOW consult6
   ON KEY LABEL ENTER
   ON KEY LABEL F8

   IF LASTKEY()#27
      wcco = codigo
      wncc = nombre
   ELSE
      STORE ' ' TO wcco,wncc
   ENDIF

ELSE
   IF ABRIR0('cencosto',1) AND SEEK(nitw+wcco)
      IF estado = 'A'
         wncc = nomccosto
      ELSE
         STORE ' ' TO wcco
         STORE ' * * C.C. INACTIVO * *' TO wncc
      ENDIF
   ELSE
      STORE ' ' TO wcco, wncc

   ENDIF
ENDIF

SHOW GET wcco
SHOW GET wncc
RETURN .T.
******

FUNCTION v_grupnom
PARAMETER _kgru,_var2, _var3
IF EMPTY(_kgru)
   wgru2 = ' '
   SHOW GET wgru2
   RETURN .T.
ENDIF
RETURN v_grunom(_kgru,'wgru2',.T.)
******

FUNCTION f_dias
* total dias laborados
PARAMETER _xcod, _xcnt, _xneg, _xhrs
_area_0 = select()
_xdias  = 0
SELECT dtem13
SET ORDER TO 6
SET RELATION TO liqcon INTO concepto
IF SEEK(_xcod)
   SUM IIF((concepto.codcon02='BASICO'  OR concepto.codcon02="BE ") AND concepto.tiempo='H', liqnrohrs, 0), ;
       IIF((concepto.codcon02='BASICO'  OR concepto.codcon02="BE ") AND concepto.tiempo='D', liqnrohrs, 0) ;
    TO _xhrbas, _xdibas ;
   FOR liqano=xano AND liqmes = mesw  AND liqestado='A';
   AND liqempre=_xneg AND liqcontrat =  _xcnt ;
   WHILE liqemple = _xcod

   _xdias = _xdibas+ROUND(_xhrbas/_xhrs,2)

ENDIF
SELECT (_area_0)
RETURN _xdias
******

FUNCTION f_dias1
* total dias lab+inc+vac
PARAMETER _xcod, _xcnt, _xneg, _xhrs
_area_0 = select()
_xdias  = 0
SELECT dtem13
SET ORDER TO 6
SET RELATION TO liqcon INTO concepto
IF SEEK(_xcod)
   SUM IIF((concepto.codcon02='BASICO'  OR concepto.codcon02="BE ") AND concepto.tiempo='H', liqnrohrs, 0), ;
       IIF((concepto.codcon02='BASICO'  OR concepto.codcon02="BE ") AND concepto.tiempo='D', liqnrohrs, 0), ;
       IIF((concepto.codcon02='INCAPAC' OR concepto.codcon02="VACLEG") AND concepto.tiempo='D', liqnrohrs, 0) ;
    TO _xhrbas, _xdibas, _xinvac ;
   FOR liqano=xano AND liqmes = mesw  AND liqestado='A';
   AND liqempre=_xneg AND liqcontrat =  _xcnt ;
   WHILE liqemple = _xcod

   _xdias = _xdibas+_xinvac+ROUND(_xhrbas/_xhrs,2)

   IF TYPE("diaslab") ='N'
      diaslab = _xdibas+ROUND(_xhrbas/_xhrs,2)
   ENDIF

   IF TYPE("dincvac") = "N"
      dincvac = _xinvac
   ENDIF

ENDIF
SELECT (_area_0)
RETURN _xdias
******

FUNCTION f_hrslab
PARAMETER  _xcod, _xcnt

SELECT dtem13
SET ORDER TO 6
SET RELATION TO liqcon INTO concepto
IF SEEK(_xcod)
   SUM IIF((concepto.codcon02='BASICO'  OR concepto.codcon02="BE ") AND concepto.tiempo='H', liqnrohrs, 0), ;
       IIF((concepto.codcon02='BASICO'  OR concepto.codcon02="BE ") AND concepto.tiempo='D', liqnrohrs, 0) ;
    TO _xhrbas, _xdibas ;
   FOR liqestado='A' AND liqcontrat =  _xcnt AND consec=wconsec ;
   WHILE liqemple  = _xcod

*   _xdias = _xdibas+ROUND(_xhrbas/_xhrs,2)

ELSE
    STORE 0 TO _xhrbas, _xdibas
ENDIF

RETURN _xhrbas
******

FUNCTION v_primas
DO CASE
   CASE wl_primas = 1
        sn = [N]
        sn1= [N]

   CASE wl_primas = 2
        sn = [S]
        sn1= [N]

   CASE wl_primas = 3
        sn = [S]
        sn1= [S]

   CASE wl_primas = 4
        sn = [P]
        sn1= [N]

   CASE wl_primas = 5
        sn = [V]
        sn1= [N]

   CASE wl_primas = 6
        sn = [V]
        sn1= [S]
ENDCASE
RETURN .T.
******

FUNCTION f_difdias
PARAMETER wd_fec2,wd_fec1,wc_neg
_area_ = SELECT()
SELECT 0
USE EMPRESAS SHARED AGAIN ALIAS q_neg ORDER 1 NOUPDATE
IF SEEK(wc_neg)
      wn_dias_ = wd_fec2 - wd_fec1 + 1
      _i = wd_fec1
      DO WHILE _i <= wd_fec2
         DO CASE
            CASE MONTH(_i) = 1  AND DAY(_i)=31 AND q_neg.ene31 = 0
                 wn_dias_ = wn_dias_ - 1
            CASE MONTH(_i) = 2  AND MONTH(_i+1)=3 AND q_neg.feb30 > 0
                 wn_dias_ = wn_dias_ + (30-DAY(_i))
            CASE MONTH(_i) = 3  AND DAY(_i)=31 AND q_neg.mar31 = 0
                 wn_dias_ = wn_dias_ - 1
            CASE MONTH(_i) = 5  AND DAY(_i)=31 AND q_neg.may31 = 0
                 wn_dias_ = wn_dias_ - 1
            CASE MONTH(_i) = 7  AND DAY(_i)=31 AND q_neg.jul31 = 0
                 wn_dias_ = wn_dias_ - 1
            CASE MONTH(_i) = 8  AND DAY(_i)=31 AND q_neg.ago31 = 0
                 wn_dias_ = wn_dias_ - 1
            CASE MONTH(_i) = 10 AND DAY(_i)=31 AND q_neg.oct31 = 0
                 wn_dias_ = wn_dias_ - 1
            CASE MONTH(_i) = 12 AND DAY(_i)=31 AND q_neg.dic31 = 0
                 wn_dias_ = wn_dias_ - 1
         ENDCASE
         _i = _i + 1
      ENDDO
ELSE
      wn_dias_ = wd_fec2 - wd_fec1 + 1
ENDIF
USE IN q_neg

SELECT (_area_)
RETURN wn_dias_
******

PROCEDURE obj_sal2
_CUROBJ = OBJNUM(wb_sal)
RETURN
******

FUNCTION w_gru
IF _wuser $ "SUP,A01,GAP"
   SHOW GET wb_sal,3 ENABLE
ELSE
   SHOW GET wb_sal,3 DISABLE
ENDIF
RETURN .T.
******

PROCEDURE p_param2
USE para7srh ORDER 1 IN 0 ALIAS tp7 AGAIN
SELECT tp7

ON KEY LABEL F12 DO ADD_RECTP7 WITH "CNC"
ON KEY LABEL F8  KEYBOARD "{CTRL+W}" PLAIN
ON KEY LABEL F5  DO COP_RECTP7
BROWSE NORMAL KEY "CNC" TITLE "Parametros de Conceptos"

ON KEY LABEL F12 DO ADD_RECTP7 WITH "RTF"
BROWSE NORMAL KEY "RTF" TITLE "Parametros de Concepto Rte fte"
ON KEY LABEL F12
ON KEY LABEL F8
ON KEY LABEL F5

USE IN tp7

USE flex7srh ORDER 1 IN 0 ALIAS tf7 SHARED AGAIN
SELECT tf7
BROWSE KEY "USUARIOS"
USE IN tf7
RETURN
******

PROCEDURE Cop_RecTP7
SCATTER MEMVAR MEMO
APPEND BLANK
GATHER MEMVAR MEMO
SCATTER MEMVAR BLANK
RETURN
******

PROCEDURE Add_RecTP7
PARAMETER _tipotp7
APPEND BLANK
REPLACE tipo WITH _tipoTp7
RETURN
******

FUNCTION abrir0
PARAMETER _tabla_7,_orden_7,_alias_7
IF TYPE("_alias_7")="L" OR EMPTY(_alias_7)
   _alias_7 = _tabla_7
ENDIF

   IF USED(_alias_7)
      SELECT (_alias_7)
      USE (_tabla_7) AGAIN SHARED ORDER _orden_7 ALIAS (_alias_7) NOUPDATE
   ELSE
      USE (_tabla_7) AGAIN SHARED ORDER _orden_7 ALIAS (_alias_7) NOUPDATE IN 0
      SELECT (_alias_7)
   ENDIF

RETURN USED(_alias_7)
******

*       *********************************************************
*       *                                                         
*       * _3HK0Z7J1M           wb_sal VALID                       
*       *                                                         
*       * Function Origin:                                        
*       *                                                         
*       * From Platform:       Windows                            
*       * From Screen:         LIQNOM,     Record Number:   63    
*       * Variable:            wb_sal                             
*       * Called By:           VALID Clause                       
*       * Object Type:         Push Button                        
*       * Snippet Number:      1                                  
*       *                                                         
*       *********************************************************
*
FUNCTION _3hk0z7j1m     &&  wb_sal VALID
#REGION 1
ON KEY LABEL PGDN

SHOW GET wb_sal,wb_sal DISABLE

DO CASE
   CASE wb_sal = 1
        DO _procesar

   CASE wb_sal = 2
        ON KEY LABEL F12
        ON KEY LABEL ENTER
        DO close_data
        CLEAR READ

   CASE wb_sal = 3
        DO p_param2

ENDCASE
RETURN
******